#ifndef __MACROS_H__
#define __MACROS_H__

// declares/defines the singleton stuff in the class body
// note that the instance itself has to be defined in a CPP file
#define CIAO_SINGLETON(CLASS)\
	private:\
	static CLASS the##CLASS##_;\
	protected:\
	CLASS(){}\
	public:\
	static CLASS& Inst(){ return the##CLASS##_;}


#ifdef cfCIAO_DECOUPLE
    #define CIAO_CLASS(CLASS, IMPL) CLASS
    #define CIAO_CLASS_BODY(CLASS, IMPL)\
		struct Impl;\
		Impl* impl();\
		const Impl* impl() const;\
		CIAO_SINGLETON(CLASS)
	#define CIAO_CLASS_DEF(CLASS, IMPL) \
	  struct CLASS::Impl : public IMPL {};\
	  inline CLASS::Impl* CLASS::impl() { return static_cast< Impl* >( &Impl::Inst() ); }\
	  inline const CLASS::Impl* CLASS::impl() const { return static_cast< const Impl* >( &Impl::Inst() ); }
#else
	#define CIAO_CLASS(CLASS, IMPL) CLASS : public IMPL
	#define CIAO_CLASS_BODY(CLASS, IMPL)\
		typedef IMPL Impl;\
		Impl* impl() { return this; }\
		const Impl* impl() const { return this; }\
		CIAO_SINGLETON(CLASS)
	#define CIAO_CLASS_DEF(CLASS, IMPL) 
#endif


#endif // __MACROS_H__
