#include <stdio.h>
#include "ostrap.ah"

extern "C" int __OS_BEGIN;
extern "C" int __OS_END;
extern "C" int __CIAO_BEGIN;
extern "C" int __CIAO_END;

inline bool isCIAO_method( void* addr ) {
	return ( &__CIAO_BEGIN <= addr ) && ( addr <= &__CIAO_END );
}

inline bool isOS_method( void* addr ) {
	return ( &__OS_BEGIN <= addr ) && ( addr <= &__OS_END );
}


void ostrap::trap( AC::Action& action ) {

	// We need to find the return address on the stack
	// This requires some hackery here in C++, however, should
	// not be no problem if using real traps 
//	#ifdef OS_INLINE
//		#define RTS_OFFSET 2
//	#else
		#define RTS_OFFSET 3
//	#endif

	void* stack[1];
	stack[ 0 ] = stack[ RTS_OFFSET ];


	printf("osstrap::trap(), checking originator (%p) and target (%p):\n", stack[ 0 ], action._wrapper );
	if( isCIAO_method( stack[ 0 ] ) )
		printf("  [OK]  invoked from namespace ciao\n");
	else
		printf("  [ERR] invoked from untrusted code!\n");
	
	if( isCIAO_method( (void*) action._wrapper ) )
		printf("  [OK]  action to call is in ciao\n");
	else
		printf("  [ERR] action to call is unknown!\n");

	action.trigger();

}
