
my $APPNAME = $ENV{'PWD'};
$APPNAME =~ s/^.*\///;

$VAR=	{
	'vname' => 'I4Copter Software',
	'name' => 'test_demos_copter',
	'dir'  => "app/$APPNAME",
	'comp' => [
		{
			'vname' => 'Common Files',
			'files' => [
				'appcode.cpp',
				'appcode.h',
				'buffer.h',
				'copter.config',
				'hwInit.ah',
				'run.cmm',
			]
		},
		{
			'vname' => 'Application Generator Scripts',
			'subdir' => 'ciao_generate',
			'comp' => [
			{
				'vname' => 'Common',
				'files' => [
					'EthernetTelemetry_collector.h.pl',
					'provider_specializations.h.pl',
					'SPICom_distributer.h.pl',
				],
			},
			{
				'vname' => 'Java only',
				'depends' => '&cfcopter_flightcontrol_java and not &cfcopter_flightcontrol_c',
				'files' => [
					'provider_specializations.cpp.pl',
				],
			},
			],
		},
		{
		'srcfile' => 'Makefile.app',
		'file' => 'Makefile',
		},
		{
			vname => "config.xml",
			comp => [
			{
				'file'=>'config.xml',
				'depends' => 'not &cfcopter_flightcontrol_java',
				'generate'=>'generate_config_xml();'
			},
			{
				'create_symlink' => [ "Keso_$APPNAME/config.xml", 'config.xml' ],
				'depends' => '&cfcopter_flightcontrol_java',
			},
			],
		},
		{
			'file'=>'network_config.h',
			'generate'=>'generate_network_config();'
		},
		{
			'vname' => 'Implementation Parts',
			'subdir' => 'copter',
			'file' => 'System',
			'except_regexp' => '^PxRos$',
		 	'comp' => [
			{
				'name' => 'Copter_Component_CopterControlTask',
				comp => [
				{
					'depends' => '&cfcopter_coptercontrol_c',
					'file' => 'CopterControlTask',
					'except_regexp' => '^PxRos$',
				},
				],
			},
			{
				'name' => 'Copter_Component_EthernetTask',
				comp => [
				{
					'depends' => '&cfcopter_ethernet_c',
					'file' => 'EthernetTask',
					'except_regexp' => [
						'^PxRos$',
						'^idtest\.cpp$',
					],
				},
				],
			},
			{
				'name' => 'Copter_Component_FlightControlTask',
				comp => [
				{
					'depends' => '&cfcopter_flightcontrol_c',
					'file' => 'FlightControlTask',
					'except_regexp' => '^PxRos$',
				},
				{
					'depends' => 'not &cfcopter_flightcontrol_c',
					'file' => 'FlightControlTask',
					'except_regexp' => [
						'\.c',
						'^PxRos$',
					],
				},
				],
			},
			{
				'name' => 'Copter_Component_NavigationTask',
				comp => [
				{
					'depends' => '&cfcopter_navigation_c',
					'file' => 'NavigationTask',
					'except_regexp' => '^PxRos$',
				},
				],
			},
			{
				'name' => 'Copter_Component_SignalProcessingTask',
				comp => [
				{
					'depends' => '&cfcopter_signalprocessing_c',
					'file' => 'SignalProcessingTask',
					'except_regexp' => '^PxRos$',
				},
				],
			},
			{
				'name' => 'Copter_Component_SPIComTask',
				comp => [
				{
					'depends' => '&cfcopter_spicom_c',
					'file' => 'SPIComTask',
					'except_regexp' => '^PxRos$',
				},
				{
					'depends' => 'not &cfcopter_spicom_c',
					'file' => 'SPIComTask',
					'except_regexp' => [
						'\.c',
						'^PxRos$',
					],
				},
				],
			},
			],
		},
	],
};
