#include "appcode.h"
#include "as/AS.h"
#include "objects.h"

#include "fsm/fsm.h"
#include "device/photosensor.h"
#include "device/coil.h"
#include "control/sequence.h"
#include "device/coil.h"
//#include "device/stopwatch.h"

void errorCallback(bool risingEdge, char sensorno) {
	PHOTOSENSOR_EnableRisingEdge();
	PHOTOSENSOR_EnableFallingEdge();
	
	COIL_AllOff();
	if(!risingEdge) {
		// TODO 
		COIL_On(sensorno);
		unsigned long long time=0;
		
		/* activly wait for 15 ms */
		//STOPWATCH_Start(0);
		do {
		//	time = STOPWATCH_Stop(0);
			
		} while(time < 25000);
		
		COIL_Off(sensorno);
	}
}

/*! The FSMTask executes one or more steps of the FSM(-Module)
 *  
 *  The FSMTask must be started at startup,
 *  in the current Proosek configuration this is done, by 
 *  autostart this task at startup
 */
void FSM::functionTaskFSMTask() {
	int timeToNextStep;

	/* Execute step and look how many milliseconds we have to wait.
	 * If instant next step of fsm is needed, then redo call
	 * to FSM_Step immediately
	 */
	do {
		timeToNextStep = FSM_Step();
	} while(timeToNextStep == 0);
	
	/* If we must wait for some milliseconds, then we set the SysAlarm
	 * to wait for that time; the alarm is configured to acitvate the FSM_Task
	 * when time exceeded
	 */
	if(timeToNextStep > 0) {
		AS::SetRelAlarm(SysAlarm, timeToNextStep, 0);
	}
	
	// Task done
	AS::TerminateTask();
}

