#include "control/command.h"
#include "control/sequence.h"

static int i = 0;
static bool started = false;

void SEQUENCE_Start() {
	started = true;
}

static command commands[] = {
	/* OscContinuous(1,1) */
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	
	/* OscContinuous(2,1) */
	{MOVE_UP,2},
	{MOVE_HOLD,18},
	{MOVE_DOWN,2},
	{MOVE_RELEASE,4},
	
	/* OscContinuous(3,1) */
	{MOVE_UP,3},
	{MOVE_HOLD,18},
	{MOVE_DOWN,3},
	{MOVE_RELEASE,4},
	
	/* OscContinuous(4,1) */
	{MOVE_UP,4},
	{MOVE_HOLD,18},
	{MOVE_DOWN,4},
	{MOVE_RELEASE,4},
	
	/* OscContinuous(5,1) */
	{MOVE_UP,5},
	{MOVE_HOLD,18},
	{MOVE_DOWN,5},
	{MOVE_RELEASE,4},
	
	/* OscContinuous(6,1) */
	{MOVE_UP,6},
	{MOVE_HOLD,18},
	{MOVE_DOWN,6},
	{MOVE_RELEASE,4},

	/* OscContinuous(7,1) */
	{MOVE_UP,7},
	{MOVE_HOLD,18},
	{MOVE_DOWN,7},
	{MOVE_RELEASE,4},

	/* 1 OscContinuous(1,4) */
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	/* 1 UpContinuous(1) */
	/* 2 OscContinuous(1,4) */
	{MOVE_UP,2},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	/* 2 UpContinuous(1) */
	/* 3 OscContinuous(1,4) */
	{MOVE_UP,2},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	
	/* 3 UpContinuous(1) */
	/* 4 OscContinuous(1,4) */
	{MOVE_UP,2},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	/* 4 UpContinuous(1) */
	/* 5 OscContinuous(1,4) */
	{MOVE_UP,2},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	/* 5 UpContinuous(1) */
	/* 6 OscContinuous(1,4) */
	{MOVE_UP,2},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	/* 6 UpContinuous(1) */
	/* 7 OscContinuous(1,4) */
	{MOVE_UP,2},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},
	{MOVE_UP,1},
	{MOVE_HOLD,18},
	{MOVE_DOWN,1},
	{MOVE_RELEASE,4},

	/* 7 UpContinuous(1) */
	{MOVE_UP,1},
	{MOVE_HOLD,18},

	/* DownContinuous(prog, 4) */
	/* OscContinuous(prog, -3, 4); */
	{MOVE_DOWN,7},
	{MOVE_RELEASE,4},
	{MOVE_UP,3},
	{MOVE_HOLD,18},
	{MOVE_DOWN,3},
	{MOVE_RELEASE,4},
	{MOVE_UP,3},
	{MOVE_HOLD,18},
	{MOVE_DOWN,3},
	{MOVE_RELEASE,4},
	{MOVE_UP,3},
	{MOVE_HOLD,18},
	{MOVE_DOWN,3},
	{MOVE_RELEASE,4},
	{MOVE_UP,3},
	{MOVE_HOLD,18},

	/* DownContinuous(prog, 3); */
	{MOVE_DOWN,3},
	{MOVE_HOLD,300},

	{MOVE_END,0}

};

command SEQUENCE_GetCommand() {
	command ret;
	if(started) {
		ret = commands[i];
		if(ret.mtype != MOVE_END) {
			++i;
		}
	} else {
		ret.mtype = MOVE_END;
		ret.n = 0;
	}
	
	return ret;
}




