#
# Makefile for simple CiAO test programs
#

# Expected Environent:
#
# CIAOBASE:    directory with the CiAO os source (i.e., the trunk/os subdirectory)

#CIAOVARIANT := $(CIAOBASE)/kconf/config
CIAOVARIANT := ../..

# default target 
default : all

# Root directory of CiAO
ROOT_DIR ?= $(CIAOVARIANT)
include $(ROOT_DIR)/make/standard.mk

APP      := $(shell basename $(PWD))

# Compile and link the test sources
SRC_DIR      := $(PWD)
EXTRA_AH_DIR := $(SRC_DIR)
OUT_DIR      := $(SRC_DIR)

# Additional g++ Flags
CXXFLAGS += -g -O3 -finline -I$(CIAO_DIR) -fdata-sections -DBUILDELF
#LDFLAGS := -T $(OUT_DIR)/ldciao.x
AGXXFLAGS := --keep_acc
#LIBS = m c cmini gcc ciao nosys ciao
MODULES	:= architecture generate ciao compile gcc

# include modules
ifneq "$(MODULES)" ""
    include $(patsubst %,$(MODULES_DIR)/%.mk,$(MODULES))
endif

MODULES_CLEAN += app
MODULES_ALL   += app

all_app: $(GEN) $(APP).elf

clean_app:
	@find $(OUT_DIR) -name "*.o" -name "*.acc" -name "$(APP).elf" -delete

# process 'all' targets in every MODULE and generate object files
all: $(patsubst %,all_%,$(MODULES_ALL))  
	
# process 'clean' targets in every MODULE and generate object files
clean: $(patsubst %,clean_%,$(MODULES_CLEAN))
	
.PHONY: all clean all_app clean_app

mrproper:
	@[ -d "$(CIAOVARIANT)" ] || ( echo 'Set $$CIAOVARIANT first' ; exit 1 )
	find "$(CIAOVARIANT)" \( -name '*.acp' -o -name '*.a' -o -name '*.o' -o -name '*.acc' -o -name '*.elf' -o -name ciao.map \) -a -delete

