#include  "os/krn/OSControl.h"
#include "cfAttribs.h"

extern "C" {
	static char heap_area[cfOS_HEAP_SIZE];

	int __ciao_stdio_putc( char ch );

	void _exit(int s) {
		os::krn::OSControl::Inst().shutdownOS( (StatusType) s);
	}

	int write(int fd, char *buf, int len) {
		int i;
		for(i=0; i<len; i++) {
			int ret = __ciao_stdio_putc(buf[i]);
			if(ret != 1) break;
		}

		return i;
	}

	void *sbrk(int incr) {
		static char *brk = heap_area;

		char *new_brk = brk + incr;
		if(new_brk >= (heap_area + sizeof(heap_area))) {
			return (void*)-1;
		}
		brk = new_brk;
		return (brk-incr);
	}
}
