# MODULE: ciao
#
# defines configuration-specific make variables to be included by projects that use CiAO.
# 


# The CiAO-Libraries to link 
ifeq ($(wildcard $(ROOT_DIR)/libcmini/Makefile),)
CIAO_LIBS := ciao
else
CIAO_LIBS := cmini ciao cmini  
endif

# The extra CXXFLAGS/AGXXFLAGS to use. These are given as last flags to the compiler
CIAO_CXXFLAGS 	:= -I$(CIAO_DIR) -I$(LIBC_DIR) -fno-builtin

#CIAO_AGXXFLAGS 	:= -I$(CIAO_DIR) -I$(LIBC_DIR) -p$(CIAO_DIR) -r $(CIAO_DIR)/ciao.acp 
CIAO_AGXXFLAGS 	:= -I$(CIAO_DIR) -I$(LIBC_DIR) -p$(CIAO_DIR)
export ACNEWREPO:=$(CIAO_DIR)/ciao.acp
 
# The CIAO-specific startup-code and linker files. These are given as first objects to the linker.
CIAO_LINKFIRST := -nostdlib

# here p::v potentially adds elements to the above variables
include $(ROOT_DIR)/make/ciao_config.mk

# application specific aspects
EXTRA_AH  := $(shell find $(EXTRA_AH_DIR) -name '*.ah' )

#export APP_DIR

libciao: $(LIB_DIR)/libciao.a
libcmini: $(LIB_DIR)/libcmini.a


# if the application specific aspects have changed, we have to recompile libciao
#@echo "appdir: $(APP_DIR)"
$(LIB_DIR)/libciao.a: $(EXTRA_AH)
	@echo "(MAKE)    $@ with extra aspects: $(notdir $(EXTRA_AH))"
	cd $(CIAO_DIR) && $(MAKE) $(if $(EXTRA_AH_DIR),EXTRA_AH_DIR="$(EXTRA_AH_DIR)") $(if $(EXTRACXXFLAGS),EXTRACXXFLAGS="$(EXTRACXXFLAGS)") --no-print-directory all

$(LIB_DIR)/libcmini.a: 
	@cd $(ROOT_DIR) && $(MAKE) --no-print-directory all_libcmini

	
.PHONY: libciao libcmini
