# C++ binutils for tricore



# Tricore-gcc is located under /proj/i4ciao/tools/trigcc
# which is different from all other architectures.
# Therefore we have to override the defaults from gcc.mk

CXX_PATH	?= /proj/i4ciao/tools/trigcc/bin
GCC_ARCH 	:= tricore

# binutils for TRICORE

OBJCOPY = $(CXX_PATH)/tricore-objcopy
LD      = $(CXX_PATH)/tricore-g++ 
SIZE    = $(CXX_PATH)/tricore-size
AR      = $(CXX_PATH)/tricore-ar
AS      = $(CXX_PATH)/tricore-g++ 
CXX 	= $(CXX_PATH)/tricore-g++

# tricore specific C++ flags
# tricore-gcc 4 does not support all compiler flags used in v3
CXX_VERSION = $(shell $(CXX) --version | head -1 | sed -e 's/.*g++ (.*) \([0-9]\+\.[0-9]\+\.[0-9]\+\).*/\1/')
ifeq ($(shell (( $(subst .,,$(CXX_VERSION)) >= 400 )) && echo 1),1)
CXXFLAGS_ARCH	:= -mcpu=tc1796 $(patsubst %,-I%,$(VPATH)) -DTRIBOARD_TC1796 -funit-at-a-time -fno-reorder-blocks 
else
CXXFLAGS_ARCH	:= -mcpu=tc1796 -mnocallerrors $(patsubst %,-I%,$(VPATH)) -DTRIBOARD_TC1796 -funit-at-a-time -fno-reorder-blocks 
#CXXFLAGS_ARCH	:= -mcpu=tc1796 -mnocallerrors -mall-errata $(patsubst %,-I%,$(VPATH)) -DTRIBOARD_TC1796
endif

ASFLAGS_ARCH	:= $(CXXFLAGS_ARCH)
LDFLAGS_ARCH	:=  -mcpu=tc1796
#LDFLAGS_ARCH	:=  -mcpu=tc1796 -mall-errata 
   
CXXFLAGS += -ffunction-sections 
ASFLAGS  += -ffunction-sections
LDFLAGS  += --gc-sections

# we link with g++, therefore transform LDFLAGS
LINKFLAGS := $(LDFLAGS_ARCH)
LINKFLAGS += $(foreach opt,$(LDFLAGS),-Xlinker $(opt))


# how to link a tricore elf binary 
$(APP).elf : $(OBJ) $(CIAO_LIBS:%=$(LIB_DIR)/lib%.a)
	@echo $(OBJ) $(CIAO_LIBS:%=$(LIB_DIR)/lib%.a)
	@echo "(LINK)    $(APP).elf"
	$(LD) $(LINKFLAGS) -o $(OUT_DIR)/$(APP).elf $(CIAO_LINKFIRST) $(OBJ) -L$(LIB_DIR) $(CIAO_LIBS:%=-l%) $(LIBS:%=-l%)

