#
# MODULE: standard
#
# defines standard paths and settings for apps, tests, and ciao

# shell
SHELL 		:= /bin/bash

# root directory of CiAO (typically "os")
# ROOT_DIR has to be (conditionally) defined by including makefile!

# we make ROOT_DIR absolute, hence effectively everything absolute. 
# this allows us to use a shared puma.config for apps and ciao
override ROOT_DIR := $(abspath $(ROOT_DIR))

# make modules directory
MODULES_DIR = $(ROOT_DIR)/make

# CiAO sources directory
CIAO_DIR = $(ROOT_DIR)/src

# libcmini sources directory
LIBC_DIR = $(ROOT_DIR)/libcmini

# applications directory
APPS_DIR = $(ROOT_DIR)/app

# tests directory
TESTS_DIR = $(ROOT_DIR)/test

# output directory for object files and libciao (and maybe other libs)
LIB_DIR = $(ROOT_DIR)/lib


# Modules that provide a 'clean_<MODULENAME>:' target 
# ! every module adds its own entry !
MODULES_CLEAN := 

# Modules that provide an 'all_<MODULENAME>:' target
# ! every module adds its own entry !
MODULES_ALL := 

