#ifndef __ciaoTYPES_H__
#define __ciaoTYPES_H__

#include "../cfAttribs.h"
#include "util/types.h"

namespace os { namespace krn {
#ifdef cfOS_NUMBER_OF_TASKS
	// data type to represent number of tasks plus INVALID_TASK
	// sirupfis 14.02.2008
	// typedef uint_t_value <(cfOS_NUMBER_OF_TASKS + 1)>::T Tasktype;
	// set to int so the pcp can handle this correctly
	typedef UInt32 TaskType; 
	const TaskType INVALID_TASK = cfOS_NUMBER_OF_TASKS;

	typedef enum {
		TASK_SUSPENDED = 0,
		TASK_READY     = 1,
		TASK_RUNNING   = 2,
		TASK_WAITING   = 3
	} TaskStateType;

	typedef void (*TaskFunc)();
#endif

#ifdef cfOS_MAX_NUMBER_OF_ACTIVATIONS
	// sirupfis 14.02.2008
	// typedef uint_t_value <cfOS_MAX_NUMBER_OF_ACTIVATIONS>::T ActivationsType;
	typedef UInt32 ActivationsType; // set to int so the pcp can handle this correctly
#endif

#ifdef cfOS_NUMBER_OF_APPLICATION_MODES
	typedef uint_t_value <(cfOS_NUMBER_OF_APPLICATION_MODES)>::T AppModeType;
	const AppModeType OSDEFAULTAPPMODE = 0;
#endif

#if cfOS_MAX_NUMBER_OF_EVENTS_PER_TASK>0
	typedef int_t<((cfOS_MAX_NUMBER_OF_EVENTS_PER_TASK-1)/8)+1,false>::T EventMaskType;
#endif

#ifdef cfOS_NUMBER_OF_OSAPPLICATIONS 
	class Application;
	typedef uint_t_value <(cfOS_NUMBER_OF_OSAPPLICATIONS + 1)>::T ApplicationType;
	const ApplicationType INVALID_OSAPPLICATION = cfOS_NUMBER_OF_OSAPPLICATIONS;
#endif
}}

#endif
