%define	REGSIZE (__BITS__/8)

%if	__BITS__ == 64
%define	STACK_PTR	rsp
%define	ACCU		rax
%define	BASE		rbx
%define	COUNTER		rcx
%define	DATA		rdx
%else
%define	STACK_PTR	esp
%define	ACCU		eax
%define	BASE		ebx
%define	COUNTER		ecx
%define	DATA		edx
%endif

SECTION .text

;; TODO: Dieses "extern" verursacht zur Laufzeit einen SEGV
; extern	__pthread_initialize_minimal
extern	__main
extern	main
	
%macro  print 1
	mov eax, 4
	mov ebx, 1
	mov ecx, %1
	mov edx, %1.len
	int 0x80
%endmacro

global _start:function
_start:
	print	bootmessage
	print	version

	;;; notwendig, um GPFs innerhalb der Syscall-Wrapper (write, read, etc.) zu vermeiden
	;;; (aber: s. o.)
	;;  initialize gs register to point at TLS
	;;  call	__pthread_initialize_minimal

	;; Kernel-Parameter auslesen
	mov	ACCU, [STACK_PTR]
	mov	[argc], ACCU

	mov	ACCU, STACK_PTR
	add	ACCU, REGSIZE
	mov	[argv], ACCU
	
	call	__main
	call	main

	print	endmessage
	
.end:	call	_fini
	mov	eax, 1
	int	0x80

global _fini:function
_fini:
	enter	0, 0
	push	ACCU
	push	BASE
	push	COUNTER
	push	DATA
	
	print	finimessage
	
	;; ggf. weiterer Cleanup-Code...

	pop	DATA
	pop	COUNTER
	pop	BASE
	pop	ACCU
	leave
	ret

SECTION .data
%defstr		USER	%!USER
%define		CLEAR	`\033[2J`
%define		HOME	`\033[1;1H`
%define		NORMAL	`\033[0m`
%define		RED	`\033[31m`
%define		GREEN	`\033[32m`
%define		YELLOW	`\033[33m`
%define		BLUE	`\033[34m`
%define		BRIGHT	`\033[1m`
%define		FAINT	`\033[2m`
%define		CURON	`\033[?25h`
%define		CUROFF	`\033[?25l`

bootmessage:	db	GREEN, "Starting ", BRIGHT, BLUE, "C", NORMAL, RED, "i", BRIGHT, BLUE, "AO", NORMAL, GREEN, "...", 10
.len:		equ	$-bootmessage
	
version:	db	GREEN, "Version: ", __DATE__, " ", __TIME__, " (", USER, ")", NORMAL, 10
.len:		equ	$-version
	
endmessage:	db	BRIGHT, RED, "end of main() reached...", 10
.len:		equ	$-endmessage

finimessage:	db	NORMAL, GREEN, "Shutdown ", BRIGHT, BLUE, "C", NORMAL, RED, "i", BRIGHT, BLUE, "AO", NORMAL, GREEN, "...", NORMAL, CURON, 10
.len:		equ	$-finimessage

SECTION .bss
global argc
argc:		resq	1

global argv
argv:		resq	1
