#ifndef HW_DEV_LAN91_H_
#define HW_DEV_LAN91_H_

#include <machine/intrinsics.h>
#include "stdinc.h"

namespace hw { namespace dev {

class LAN91
{
//	static LAN91 theLAN91_;

	protected:
		LAN91() {}

	private:
		static void NutDelay(uint32_t ms);
		static uint8_t NicPhyRegSelect(uint8_t reg, uint8_t we);
		static uint16_t NicPhyRead(uint8_t reg);
		static void NicPhyWrite(uint8_t reg, uint16_t val);
		static int NicPhyConfig(void);
		static int NicMmuWait(uint16_t tmo);
		static int NicReset(void);
		static int NicStart();
		static void NicWrite(uint8_t * buf, uint16_t len);
		static void NicRead(uint8_t * buf, uint16_t len);
		static const uint32_t ip;
		static const uint8_t mac[6];

	public:
		static uint16_t NicGetPacket(uint8_t *nb, uint16_t size);
		static int NicPutPacket(uint16_t len, uint8_t* nb);
		static void NicInit();
		static void network_get_MAC(uint8_t* macaddr);
		static const uint8_t* getMAC();
		static void network_set_MAC(uint8_t* macaddr);
		static uint32_t network_get_IP();
		static uint32_t getIP();

	public:
/*		static LAN91& Inst() {
			return theLAN91_;
		}*/

};

typedef LAN91 NIC;

}} // hw::dev


#endif /*LAN91_H_*/
