/** \author Christian Meier
 *  \version $Id: ConfigTypes.h 995 2009-08-11 14:26:31Z mike $
 */

#ifndef HW_DEV_CAN_CONFIG_TYPES_H
#define HW_DEV_CAN_CONFIG_TYPES_H

#include "os/com/ComStack_Types.h"
#include "../cfInitializers.h"

#include "IdType.h"
#include "HwObjectIdType.h"

namespace hw { namespace dev { namespace can {

struct ControllerConfigType {
	uint8 m_ControllerId;
	uint8 m_PropSeg;
	uint8 m_PhaseSeg1;
	uint8 m_PhaseSeg2;
};

struct HwObjectConfigType {
	// As members of the same type are best placed together into
	// a struct and IdStorageType is also the largest member type
	// we want to introduce something in the middle of the struct
	// This can be done by using a member struct element:
	struct IdStorageType_GroupingType {
		IdStorageType m_Id;
//		IdStorageType m_Mask; // Will be inserted by an advice
	} IdStorageType_Grouping;
	uint8 m_ControllerId;

	IdType
	CanId() const {
		return IdStorageType_Grouping.m_Id;
	}
};

struct ConfigType {
	HwObjectConfigType *	m_HwObjConfigArray;		//!< A pointer to an array of all hardware objects of the driver
	HwObjectIdStorageType	m_NumHwObjConfigs;
	ControllerConfigType ** m_CtrlConfigArray;	//!< A pointer to an array of pointers to all default controllers configuration indexed by controller id
	uint8 m_NumCtrlConfigs;
};

}}}

#endif /* HW_DEV_CAN_CONFIG_TYPES_H */
