/** \author Christian Meier
 *  \version $Id: CanDriverImpl.h 995 2009-08-11 14:26:31Z mike $
 */

#ifndef HW_DEV_CAN_DUMMYCAN_DRIVER_H
#define HW_DEV_CAN_DUMMYCAN_DRIVER_H


#include "os/com/ComStack_Types.h"
#include "hw/dev/can/ControllerIdType.h"
#include "../ConfigTypes.h"

namespace hw { namespace dev { namespace can { namespace dummycan {

class CanDriverImpl {
protected:
	static CanDriverImpl theDummycan_;

	CanDriverImpl() {}

public:
	static CanDriverImpl&
	Inst() {
		return theDummycan_;
	}

	void
	Init (const ConfigType * p_Config);

	void
	InitController (ControllerIdType Controller, ControllerConfigType * p_Config);

	ReturnType
	SetControllerMode (ControllerIdType Controller, StateTransitionType Transition);

	void
	DisableControllerInterrupts (ControllerIdType Controller);

	void
	EnableControllerInterrupts (ControllerIdType Controller);

	ReturnType
	Write (HwObjectIdType Hth, PduType const * PduInfo);

	void
	MainFunction_Read (void);

	void
	MainFunction_Write (void);

	void
	MainFunction_BusOff (void);

	void
	ProcessBusoff(ControllerIdType ControllerHandle);
};

}}}}

#endif
