// $Id: AST0.h 995 2009-08-11 14:26:31Z mike $
// Created:   25.03.2006 lohmann

#ifndef __HW_HAL_AST0_H__
#define __HW_HAL_AST0_H__

#include "stdinc.h"
#include "AST0Impl.h"


namespace hw { namespace hal {


class AST0 : public AST0Impl {
 public:
 	typedef AST0Impl Super;

 private:
	static AST0 theAST0_;
	void init() {
		Super::init();
		enable();
	}

 public:
	//! Returns the one-and-only AST0 instance.
	static AST0& Inst() {
		return theAST0_;
	}
	
	//! Trigger the AST0 to the CPU
	void trigger() {
		Super::trigger();
	}
	
	//! From now on, AST0 execution triggered by threads will be delayed.
	void beginDelay() {
		Super::beginDelay();
	}
	
	//! Ends a delay period started by beginDelay(), invokes pending AST0 execution.
	void endDelay() {
		Super::endDelay();
	}
	
	static void ast() {
		// Invoked by advice
		// bound to by advice
	} 
};

}} // namespace hw::hal

#endif // __HW_HAL_AST0_H__
