// $Id: DebugPort.h 1309 2010-11-17 20:33:43Z mike $
// Created:   11.03.2006 lohmann

/**
 * \file DebugPort.h
 * \brief Implements a synchronous character output for debugging and tracing purposes
 *
 */

#ifndef __HW_HAL_DEBUGPORT__
#define __HW_HAL_DEBUGPORT__

#include "DebugPortImpl.h"

namespace hw { namespace hal {

//! Synchronous character output device for debugging purposes
//
// DebugPortImpl is a type alias generated by p::v
class DebugPort : public DebugPortImpl {
	static DebugPort theDebugPort_;
  protected:
	DebugPort(){}
  public:
  
  	static DebugPort& Inst() {
  		return theDebugPort_;
  	}
  
	void print( char* what ) {
		for( ; *what; ++what )
			putc_( static_cast<UInt8>(*what) );
	}
};

}} // namespace hw::hal



#endif // __HW_HAL_DEBUGPORT__
