// $Id$

#ifndef __HW_HAL_ASTIMPL_CPUSRC1_H__
#define __HW_HAL_ASTIMPL_CPUSRC1_H__

#include "stdinc.h"
#include "hw/irq/CPU_SRC1.h"
#include "CPU.h"

namespace hw { namespace hal {


class ASTImpl_CPU_SRC1 : protected hw::irq::CPU_SRC1 {

 public:
 	typedef hw::irq::CPU_SRC1 Super;
 	
	//! Trigger the AST to the CPU
	static void trigger() {
		Super::set();
	}
	static void enable() {
		Super::enable();
	}
	static void disable() {
		Super::disable();
	}
	
	static void beginDelay() {
		// TODO: This does not work if CPU_SRC1 uses an IRQL > 1 and other ASTs are used
		STATIC_ASSERT( Super::VECTOR == 2, AST1_implementation_requires_IRQL_2 );
		hw::hal::CPU::setIRQL( Super::VECTOR );
	}
	
	//! Ends a delay period started by beginDelay(), invokes pending AST execution.
	static void endDelay() {
		hw::hal::CPU::CPU::setIRQL(1);
	}
};

}} // namespace hw::hal

#endif // __HW_HAL_ASTIMPL_CPUSRC1_H__
