// $Id: Continuation.cpp 995 2009-08-11 14:26:31Z mike $

// dispatcher code must always be inlined
// CXXFLAGS_EXTRA=-finline -finline-functions

#include "Continuation.h"

namespace hw { namespace hal {


void CIAO_NOINLINE Continuation::internal_saveAndSwitchto( Continuation* to ) {
	before_CPURelease( to );
	save();
	to->load();
}

void CIAO_NOINLINE Continuation::internal_saveAndStart( void* tos, StartFunc starter, Continuation* to ) {
	before_CPURelease( to );
	save();
	to->go( tos, starter );
	
	// we never come here
	
}

void Continuation::start_impl( Continuation* obj, void* tos, StartFunc starter, Continuation* to ) {
	obj->before_LastCPURelease( to );
	to->go( tos, starter );
}

void Continuation::saveAndStart_impl( void* tos, StartFunc starter, Continuation* to ) {
	internal_saveAndStart( tos, starter, to );
	after_CPUReceive();
}

void Continuation::switchto_impl( Continuation* obj, Continuation* to ) {
	obj->before_LastCPURelease( to );
	to->load();
}

void Continuation::saveAndSwitchto_impl( Continuation* to ){
	internal_saveAndSwitchto( to );
	after_CPUReceive();
}

}} 	// namespace hw::hal
