// $Id: TCBUser.h 1286 2010-10-13 14:05:35Z sijesche $
// Created:   19.05.2006 lohmann

/**
 * @file TCBUser.h
 * @brief Contains the definitions of the basic user-level dispatchable coroutines
 * 
 */


#ifndef __HW_HAL_TCBUSER_H__
#define __HW_HAL_TCBUSER_H__

#include "Continuation.h"	

/// The following (architecure-dependend) attributes are recommended for thread functions
#define cfHAL_THREADFUNC_ATTRIBUTES CIAO_USE_JL


namespace hw { namespace hal { 


class TCBUser;

class TCBUserBase : public Continuation {
public:

	typedef Continuation Super;		

	/**
	 * @brief The internal thread start function. 
	 * 
	 */
	static void kickoff( TCBUser* me );
};

class TCBUser : public TCBUserBase {
  public:
	typedef TCBUserBase Super;		
	
	void CIAO_INLINE init() {
		Super::init();
	}
	
	void CIAO_INLINE go( Ptr tos ) {
		Super::go( tos, (StartFunc) kickoff );
	}
	void CIAO_INLINE saveAndStart( Ptr tos, TCBUser* tcb ) {
		Super::saveAndStart( tos, (StartFunc) kickoff, tcb );
	}
	void CIAO_INLINE start( Ptr tos, TCBUser* tcb ) {
		Super::start( tos, (StartFunc) kickoff, tcb );
	} 
	void CIAO_INLINE saveAndSwitchto( TCBUser* to ) {
		Super::saveAndSwitchto( to );
	} 
	void CIAO_INLINE switchto( TCBUser* to ) {
		Super::switchto( to );
	} 
	inline int get_pcxi() {
		return _mfcr( $pcxi );
	}
  protected:
  	friend class TCBUserBase;
  	
  	// The thread function iself. Has to be adviced to
  	// implement thread functionality
  	void ThreadFunc();
};
	
} } // namespace hw::hal


#endif // __HW_HAL_TCBUSER_H__
