// $Id: Continuation.cpp 995 2009-08-11 14:26:31Z mike $

// dispatcher code must always be inlined
// CXXFLAGS_EXTRA=-finline -finline-functions

#include "Continuation.h"

namespace hw { namespace hal {


void CIAO_NOINLINE Continuation::internal_saveAndSwitchto( Continuation* to ) {
	before_CPURelease( to );
	Continuation_switch(&context_, &to->context_);
}

void CIAO_NOINLINE Continuation::internal_saveAndStart( void* tos, StartFunc starter, Continuation* to ) {
	before_CPURelease( to );

	// TODO: Code-Duplikation vermeiden
	// go (ohne load)
    to->context_.ebx = 0;
    to->context_.esi = 0;
    to->context_.edi = 0;
    to->context_.ebp = 0;

    void** ptos = (void**) tos;

    *(--ptos) = to;
    *(--ptos) = (void*) 0xdeadbeef;

    // Kickoff
    *(--ptos) = (void*) starter;
    to->context_.esp = ptos;

    // save und load
    Continuation_switch(&context_, &to->context_);

	// we never come here
}

void Continuation::start_impl( Continuation* obj, void* tos, StartFunc starter, Continuation* to ) {
	obj->before_LastCPURelease( to );
	to->go( tos, starter );
}

void Continuation::saveAndStart_impl( void* tos, StartFunc starter, Continuation* to ) {
	internal_saveAndStart( tos, starter, to );
	after_CPUReceive();
}

void Continuation::switchto_impl( Continuation* obj, Continuation* to ) {
	obj->before_LastCPURelease( to );

	// TODO: Funktion überflüssig?
	Continuation_go(&to->context_);
}

void Continuation::saveAndSwitchto_impl( Continuation* to ){
	internal_saveAndSwitchto( to );
	after_CPUReceive();
}

}} 	// namespace hw::hal
