#ifndef HW_HAL_MPU_H_
#define HW_HAL_MPU_H_

#include "stdinc.h"
//#include <hw/hal/Paging.h>

//#include <os/krn/SchedImpl.h>

// include cylce: #include <os/krn/Task.h>
/*
namespace os {
namespace krn {
extern Task theTasks [];
}
}
*/

//#include <stdio.h>

namespace hw {

namespace hal {

class MPU {
public:

	typedef long int addr;

	enum DPerm {READ = 64, WRITE = 128};
	enum CPerm {EXECUTE = 128};
	typedef UInt8 Perms;

//Methods for all MPUs

	//to be adviced by the memory protection aspects
	static void init() {
		//printf("MPU: init()\n");
	}

	static void enable() {
		//printf("MPU: enable()\n");
	}

	static void disable() {
		//printf("MPU: disable()\n");
	}

	static void setPrivateDataRange(addr lower, addr upper) {
		//printf("MPU: setPrivateDataRange(0x%x, 0x%x)\n", lower, upper);

		/* alles quatsch:
		os::krn::SchedImpl::Id task_id = os::krn::SchedImpl::Inst().getRunning();              // current task
		os::krn::Application::Id app_id = os::krn::theTasks[task_id].getApplication(task_id);  // current application

		const int tasks_num = sizeof(os::krn::theTasks) / sizeof(os::krn::Task);               // total number of tasks

		// TODO: Ziel ist es, allen Tasks der Applikation, worauf sich dieser MPU-Aufruf bezieht, Schreibzugriffe zu gewähren.
		//       Doch wie findet man heraus, welche Tasks zu dieser Applikation gehören?
		//       Zur Zeit gehen wir einfach alle Tasks durch, und prüfen jeweis, ob dieser Task zu der aktuellen Applikation gehört.
		//       Gibt's eine bessere Alternative?
		for (int i = 0; i < tasks_num; ++i) {
			// get task-context of i-th task
			hw::hal::x86Context* ctx = os::krn::SchedImpl::Inst().getTCB(i)->getContext();

			// if task belongs to current application
			if (os::krn::theTasks[i].getApplication(i) == app_id) {
				for (unsigned long i = lower; i < upper; i += 0x1000) {
					ctx->cr3_pagetable.setPage((void*) i, (void*) i, hw::hal::PageTable::PS_4k, true, true, true);;
				}
			}
		}
		*/
	}

	static void setPrivateDataPerms(Perms p) {
		//printf("MPU: setPrivateDataPerms(%x)\n", p);
	}

	static void setPrivateCodeRange(addr lower, addr upper) {
		//printf("MPU: setPrivateCodeRange()\n");
	}

	static void setPrivateCodePerms(Perms p) {
		//printf("MPU: setPrivateCodePerms()\n");
	}

	static void setStackRange(addr lower, addr upper) {
		//printf("MPU: setStackRange()\n");
	}

	static void setStackUpper(addr upper) {
		//printf("MPU: setStackUpper()\n");
	}

	static void setStackLower(addr lower) {
		//printf("MPU: setStackLower()\n");
	}

	static void setStackPerms(Perms p) {
		//printf("MPU: setStackPerms()\n");
	}

	static void permitStack() {
		//printf("MPU: permitStack()\n");
	}

	static void setLocalsRange(addr lower, addr upper) {
		//printf("MPU: setLocalsRange()\n");
	}

	static void setLocalsPerms(Perms p) {
		//printf("MPU: setLocalsPerms()\n");
	}

	static void initCommonCode(addr lower, addr upper) {
		//printf("MPU: initCommonCode()\n");
	}

	static void permitFullExecution() {
		//printf("MPU: permitFullExecution()\n");
	}

	static void initCommonRData(addr lower, addr upper) {
		//printf("MPU: initCommonRData()\n");
	}

	static void permitFullRead() {
		//printf("MPU: permitFullRead()\n");
	}

	static void leaveTrusted() CIAO_INLINE {
		//printf("MPU: leaveTrusted()\n");
	}

	static void leaveTrusted_drv() CIAO_INLINE {
		//printf("MPU: leaveTrusted_drv()\n");
	}

	inline static void enterTrusted() CIAO_INLINE {
		//printf("MPU: enterTrusted()\n");
	}

	inline static void enterPrivileged() CIAO_INLINE {
		//printf("MPU: enterPrivileged()\n");
	}

	inline static void leavePrivileged_drv() CIAO_INLINE {
		//printf("MPU: leavePrivileged_drv()\n");
	}

	inline static void leavePrivileged() CIAO_INLINE {
		//printf("MPU: leavePrivileged()\n");
	}
};

}} // hw::hal

#endif /*MPU_H_*/
