/*
 * PageTable32.h
 *
 *  Created on: 07.04.2010
 *      Author: bossel00
 */

#ifndef PAGETABLE32_H_
#define PAGETABLE32_H_

#include "BasicPageTable.h"

namespace hw {
namespace hal {

namespace paging {

// page table with 4KB pagesize for 32-Bit protected mode without physical address extension
namespace PM_4KB {
class PTE: public BasicPageTable<void*, UInt32> {
public:
	PTE(void* mem, bool present, bool writeable, bool user, bool nx = false)
	   : BasicPageTable<void*, UInt32>(mem, present, writeable, user, 1, false) {
	}
};

class PDE: public BasicPageTable<PTE*, UInt32> {
public:
	PDE(PTE* pte, bool present, bool writeable, bool user, bool nx = false)
	   : BasicPageTable<PTE*, UInt32>(pte, present, writeable, user, 0, false) {
	}
};

} // namespace PM_4KB


// page table with 4MB pagesize for 32-Bit protected mode without physical address extension
namespace PM_4MB {

class PDE: public BasicPageTable<void*, UInt32> {
public:
	PDE(void* mem, bool present, bool writeable, bool user, bool nx = false)
	   : BasicPageTable<void*, UInt32>(mem, present, writeable, user, 1, false) {
     }
};

} // namespace PM_4MB

} // namespace paging

}
}

#endif /* PAGETABLE32_H_ */
