/*
 * Paging.cpp
 *
 *  Created on: 08.04.2010
 *      Author: bossel00
 */

#include "Paging.h"
#include "ciaoConfig.h"

namespace hw {
namespace hal {

Paging Paging::inst_;

void Paging::enable() {
}

void Paging::disable() {
}

void Paging::init() {
	pagetable_.init();
	for (int i = cfHAL_PAGING_FIRST_VALID_ADDRESS; i < 8*1024*1024; i += 4096) {
		setPage(i, i, hw::hal::PageTable::PS_4k, true, true, true);
	}
}

bool Paging::setPage(void* virtual_addr, void* physical_addr, PageTable::Pagesize ps, bool writeable, bool user, bool executable) {
	return pagetable_.setPage(virtual_addr, physical_addr, ps, writeable, user, executable);
}

void Paging::clearPage(void* virtual_addr, PageTable::Pagesize ps) {
	pagetable_.clearPage(virtual_addr, ps);
}

}
}
