/** \author Christian Meier
 *  \version $Id: ControllerConfigType.h 995 2009-08-11 14:26:31Z mike $
 *
 *  One ControllerConfigType holds the configuration for one Controller.
 */

#ifndef HW_HAL_CAN_CONTROLLER_CONFIG_TYPES_H
#define HW_HAL_CAN_CONTROLLER_CONFIG_TYPES_H

#include "hw/dev/can/ConfigTypes.h"
#include "hw/dev/can/ControllerIdType.h"

#include "../cfInitializers.h"

namespace hw { namespace hal { namespace can {

struct ControllerConfigType {
	// All corresponding configs for underlying hardware controller
	hw::dev::can::ControllerConfigType * CtrlConfigs_;

	// Corresponding ControllerId of underlying hardware controller
	hw::dev::can::ControllerIdStorageType ControllerId_;

	hw::dev::can::ControllerIdType
	ControllerIdConfig() {
		return ControllerId_;
	}
};

}}}

#endif
