// $Id: ASC.h 995 2009-08-11 14:26:31Z mike $
// Created:   06.06.2006 lohmann

#ifndef ASC_H_
#define ASC_H_

#include "IRQBase.h"
#include <tc1796b/asc0/addr.h>
#include <tc1796b/asc1/addr.h>

namespace hw { namespace irq {

/**
 * @brief Provides access to TC1796 IRQ ASC0_RSRC (receive)
 *
 */
struct ASC0_REC : public IRQBase< cfIRQL_ASC0_REC, ASC0_RSRC_ADDR  > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
 * @brief Provides access to TC1796 IRQ ASC0_ESRC (error)
 *
 */
struct ASC0_ERR : public IRQBase< cfIRQL_ASC0_ERR, ASC0_ESRC_ADDR > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
 * @brief Provides access to TC1796 IRQ ASC0_TSRC (transmit)
 *
 */
struct ASC0_TRA : public IRQBase< cfIRQL_ASC0_TRA, ASC0_TSRC_ADDR > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
 * @brief Provides access to TC1796 IRQ ASC0_TBSRC (transmit buffer)
 *
 */
struct ASC0_TBUF : public IRQBase< cfIRQL_ASC0_TBUF, ASC0_TBSRC_ADDR > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
 * @brief Provides access to TC1796 IRQ ASC1_RSRC (receive)
 *
 */
struct ASC1_REC : public IRQBase< cfIRQL_ASC1_REC, ASC1_RSRC_ADDR > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
 * @brief Provides access to TC1796 IRQ ASC1_ESRC (error)
 *
 */
struct ASC1_ERR : public IRQBase< cfIRQL_ASC1_ERR, ASC1_ESRC_ADDR > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
 * @brief Provides access to TC1796 IRQ ASC1_TSRC (transmit)
 *
 */
struct ASC1_TRA : public IRQBase< cfIRQL_ASC1_TRA, ASC1_TSRC_ADDR > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
 * @brief Provides access to TC1796 IRQ ASC1_TBSRC (transmit buffer)
 *
 */
struct ASC1_TBUF : public IRQBase< cfIRQL_ASC1_TBUF, ASC1_TBSRC_ADDR > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

}} // namespace hw::irq

#endif /*ASC_H_*/

