// $Id: CPU_SRC0.h 995 2009-08-11 14:26:31Z mike $
// Created:   06.06.2006 lohmann

#ifndef HW_IRQ_CPU_SRC0_H_
#define HW_IRQ_CPU_SRC0_H_

#include "IRQBase.h"
#include <tc1796b/cps/addr.h>

namespace hw { namespace irq {

/**
 * @brief Provides access to TC1796 IRQ CPU_SRC0 (asynchronous system trap)
 *
 */
struct CPU_SRC0 : public IRQBase< cfIRQL_CPU_SRC0, CPU_SRC0_ADDR  > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

}} // namespace hw::irq

#endif /*HW_IRQ_CPU_SRC0_H_*/

