// $Id: DMA_SYSSRC2.h 995 2009-08-11 14:26:31Z mike $
// Created:   06.06.2006 lohmann

#ifndef DMA_SYSSRC2_H_
#define DMA_SYSSRC2_H_

#include "IRQBase.h"
#include <tc1796b/dma/addr.h>

namespace hw { namespace irq {

/**
 * @brief Provides access to TC1796 IRQ DMA_SYSSRC2 (dma system request 2)
 *
 * DMA_SYSSRC2 can be triggered by various sources. It is in line with the
 * SCU_REQ0 internal request line of the system control unit which, among
 * other things, may be triggered by some several of hw::dev::P0 and hw::dev::P7
 */
struct DMA_SYSSRC2 : public IRQBase< cfIRQL_DMA_SYSSRC2, DMA_SYSSRC2_ADDR  > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

}} // namespace hw::irq

#endif /*DMA_SYSSRC2_H_*/

