
// created: 08.01.2008 sirupfis

#ifndef __HW_IRQ_PCP_H__
#define __HW_IRQ_PCP_H__
 
#include "util/types.h"
#include "os/krn/Task.h"

#define PCP_CS	*((unsigned int volatile *) 0xF0043F10)	/* PCP Control/Status Register */
#define PCP_CS_EN	((Reg32Bits_T *)0xF0043F10)->bit0
#define PCP_CS_RST	((Reg32Bits_T *)0xF0043F10)->bit1
#define PCP_CS_RS	((Reg32Bits_T *)0xF0043F10)->bit2
#define PCP_CS_RCB	((Reg32Bits_T *)0xF0043F10)->bit4
#define PCP_CS_EIE	((Reg32Bits_T *)0xF0043F10)->bit5
#define PCP_CS_MCE	((Reg32Bits_T *)0xF0043F10)->bit8
#define PCP_CS_CWE	((Reg32Bits_T *)0xF0043F10)->bit16

#define PCP_ICR	*((unsigned int volatile *) 0xF0043F20)	/* PCP Interrupt Control Register */
#define PCP_ICR_IE	((Reg32Bits_T *)0xF0043F20)->bit8
#define PCP_ICR_ONECYC	((Reg32Bits_T *)0xF0043F20)->bit26

#define PCP_SRC4	*((unsigned int volatile *) 0xF0043FEC)	/* Service Request Control Register 4 */
#define PCP_SRC4_SRE	((Reg32Bits_T *)0xF0043FEC)->bit12
#define PCP_SRC4_SRR	((Reg32Bits_T *)0xF0043FEC)->bit13

extern int dptr;

#define PCP_DMEM	*((unsigned int volatile *) 0xf0050000)	/* PCP Data memory */

#define PCP_FLAG0	*((unsigned int volatile *) 0xf0050400)
#define PCP_FLAG1	*((unsigned int volatile *) 0xf0050404)
#define PCP_TURN	*((unsigned int volatile *) 0xf0050408)
#define PCP_PRIO	*((unsigned int volatile *) 0xf005040c)
#define PCP_READY	*((unsigned int volatile *) 0xf0050410)
#define PCP_PTASK	*((unsigned int volatile *) 0xf0050414)
#define PCP_NEED_RESCHEDULE	*((unsigned int volatile *) 0xf0050418)
#define PCP_TTASK	*((unsigned int volatile *) 0xf0050504)
#define PCP_TTASK_ADD 0xf0050504


namespace hw { namespace irq {

class PCP{

public:
		static void init();
		static void enable();

		// writes the priority of the running task at the beginning
		// of the global data in PCP memory (dptr)
		static void setPrio(os::krn::Task::Pri prio);
		
		// assigns a task to an interrupt priority
		// assignment ist stored in a table in PCP
		// memory
		static void setTaskInt(os::krn::Task::Pri irqprio, os::krn::Task::Pri taskprio, os::krn::Task& pTask, os::krn::Task::Id No);

};
	
}} // namespace hw::irq

#endif // __HW_IRQ_PCP_H__ 

