#ifndef HW_IRQ_IRQ_COM1_H_
#define HW_IRQ_IRQ_COM1_H_

#include "stdinc.h"
#include "IRQBase.h"

namespace hw {
namespace irq {

/**
 * @brief IRQ4 for COM1
 *
 */
class IRQ_COM1: public IRQBase {

	static const UInt8 IRQ_COM1_V = 4;

	typedef IRQBase Super;

public:
	static const UInt8 REGISTER = IRQ_COM1_V;

public:
	static void enable() {
		Super::enableIRQ(IRQ_COM1_V);
	}
	static void disable() {
		Super::disableIRQ(IRQ_COM1_V);
	}

	//! Advice should bind to this
	static Bool Handler();

	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool HWHandler();

	static void init() {
		// +32 für Hardware-Unterbrechungen
		handler_table[IRQ_COM1_V + 32] = HWHandler;
	}
};

} // namespace irq
} // namespace hw

#endif // HW_IRQ_IRQ_COM1_H_
