#include "TRAP_PageFault.h"

#include <stdio.h>

namespace hw {
namespace irq {

Bool CIAO_INLINE TRAP_PageFault::Handler() {
	// advice can bind here
	return true;
}
// The really invoked handler
Bool CIAO_WEAK TRAP_PageFault::HWHandler() {
	return Handler();
}

void TRAP_PageFault::debugHandler() {

	unsigned long addr, ip;

	// load address of page fault
	asm volatile("mov %%cr2, %0;"
			     : "=r"(addr)
			    );

	// load interrupt return address into ip
	// TODO: Was ist mit x86_64?
	asm volatile("mov 28(%%ebp), %0;"
			  : "=r"(ip)
			  );

	printf("CiAO: segfault at %lx ip %lx\nSystem halted...", addr, ip);

	for (;;)
		asm volatile("cli\nhlt");
}

} // namespace irq
} // namespace hw

