#ifndef OS_COM_DIRECT_FIXED_SIZE_BUFFER_TYPE_H
#define OS_COM_DIRECT_FIXED_SIZE_BUFFER_TYPE_H

#include "os/com/ComStack_Types.h"

namespace os { namespace com {

template <class ELEM_TYPE, int BUF_SIZE, int INST_MULTIPLICITY>
class DirectFixedSizeBufferType {
public:
	typedef ELEM_TYPE ElemType;

	template<int INST>
	ElemType *
	GetBuffer();

	template<int INST>
	ElemType const *
	GetConstBuffer() const;

private:
	ElemType RawBuffer_[INST_MULTIPLICITY][BUF_SIZE];
};

template <class ELEM_TYPE, int BUF_SIZE, int INST_MULTIPLICITY>
template <int INST>
inline typename DirectFixedSizeBufferType<ELEM_TYPE, BUF_SIZE, INST_MULTIPLICITY>::ElemType *
DirectFixedSizeBufferType<ELEM_TYPE, BUF_SIZE, INST_MULTIPLICITY>::GetBuffer() {
	return this->RawBuffer_[INST];
}

template <class ELEM_TYPE, int BUF_SIZE, int INST_MULTIPLICITY>
template <int INST>
inline typename DirectFixedSizeBufferType<ELEM_TYPE, BUF_SIZE, INST_MULTIPLICITY>::ElemType const *
DirectFixedSizeBufferType<ELEM_TYPE, BUF_SIZE, INST_MULTIPLICITY>::GetConstBuffer() const {
	return this->RawBuffer_[INST];
}

}}

#endif
