#include "RxSignalGroupType.h"
#include "RxIpduType.h"
#include "RxSignalType.h"

namespace os { namespace com { namespace ascom {

void
RxSignalGroupType::Start (Bool Initialize) {
	for (RxSignalIdType ActId = SignalIdMin (); ActId <= SignalIdMax (); ++ActId) {
		RxSignalType::Inst (ActId).Start (Initialize);
	}
}

void
RxSignalGroupType::Stop () {
	for (RxSignalIdType ActId = SignalIdMin (); ActId <= SignalIdMax (); ++ActId) {
		RxSignalType::Inst (ActId).Stop ();
	}
}

void
RxSignalGroupType::RxIndication(UInt8 const * SduPtr) {

}

StatusType
RxSignalGroupType::ReceiveSignalGroup () {
	UInt8 const * ShadowBuffer = RxIpduType::Inst (IpduId ()).ShadowBuffer ();

	for (RxSignalIdType ActId = SignalIdMin (); ActId <= SignalIdMax (); ++ActId) {
		RxSignalType::Inst(ActId).RxIndication (ShadowBuffer);
	}

	return E_OK;
}

RxSignalGroupType RxSignalGroupType::RxSignalGroups_[cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY];

}}}
