#ifndef OS_COM_RX_SIGNAL_GROUP_TYPE_H
#define OS_COM_RX_SIGNAL_GROUP_TYPE_H

#include "util/types.h"
#include "os/com/ComStack_Types.h"
#include "os/com/ascom/ConfigTypes.h"

namespace os { namespace com { namespace ascom {

class RxIpduType;

class RxSignalGroupType : public RxSignalGroupConfigType {
public:
	static void
	InitAll(RxSignalGroupConfigType const * ConfigArray, RxSignalGroupIdType NumRxSignalGroups);

	static RxSignalGroupType &
	Inst(RxSignalGroupIdType SignalId);

	RxSignalGroupIdType
	Id() const;

	void
	Init(RxSignalGroupConfigType const * ConfigPtr);

	void
	Init();

	void
	Start (Bool Initialize);

	void
	Stop ();

	void
	RxIndication(UInt8 const * SduPtr);

	StatusType
	ReceiveSignalGroup ();

private:
	static RxSignalGroupType RxSignalGroups_[cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY];
};


inline void
RxSignalGroupType::InitAll(RxSignalGroupConfigType const * ConfigArray, RxSignalGroupIdType NumRxSignalGroups) {
	RxSignalGroupIdType i = 0;

	// We assume NumRxSignalGroups <= cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY
	for(; i < NumRxSignalGroups; ++i) {
		RxSignalGroups_[i].Init(&ConfigArray[i]);
	}

	for(; i < cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY; ++i) {
		// FIXME Uninit or stop or similar
	}
}

inline RxSignalGroupType &
RxSignalGroupType::Inst(RxSignalGroupIdType SignalGroupId) {
	return RxSignalGroups_[SignalGroupId];
}

inline RxSignalGroupIdType
RxSignalGroupType::Id() const {
	return this - RxSignalGroups_;
}

inline void
RxSignalGroupType::Init(RxSignalGroupConfigType const * ConfigPtr) {
	*(RxSignalGroupConfigType*)this = *ConfigPtr;
	Init();
}

inline void
RxSignalGroupType::Init() {
}

}}}

#endif
