#ifndef OS_COM_ASCOM_RX_SIGNAL_TYPE_RX_EXTEND_H
#define OS_COM_ASCOM_RX_SIGNAL_TYPE_RX_EXTEND_H

#include "util/bitmanip.h"
#include "os/com/ascom/Cfg.h"

namespace os { namespace com { namespace ascom {

typedef void (*RxExtendType)(void* ValuePtr, Int NumBits);

namespace internal {

template <typename INT_TYPE>
struct RxExtendAlgo {
	static void Do(void * ValuePtr, Int NumBits) {
		*(INT_TYPE*)ValuePtr = bitmanip::extract_low<INT_TYPE>(*(INT_TYPE *)ValuePtr, NumBits);
	}
};

template <>
struct RxExtendAlgo<UInt8*> {
	static void Do(void * ValuePtr, Int NumBits) {
	}
};

template <>
struct RxExtendAlgo<void> {
	static void Do(void * ValuePtr, Int NumBits) {
	}
};

}

template <typename INT_TYPE>
void
RxExtendAlgo(void * ValuePtr, Int NumBits) {
	internal::RxExtendAlgo<INT_TYPE>::Do(ValuePtr, NumBits);
}

}}}

#endif
