#ifndef OS_COM_ASCOM_TX_IPDU_GROUP_TYPE_H
#define OS_COM_ASCOM_TX_IPDU_GROUP_TYPE_H

#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/ConfigTypes.h"
#include "util/container/Bitset.h"

namespace os { namespace com { namespace ascom {

class TxIpduGroupType : public TxIpduGroupConfigType {
public:
	static TxIpduGroupType &
	Inst (TxIpduGroupIdType TxIpduGroupId);

	static void
	InitAll (TxIpduGroupConfigType const * ConfigArray, TxIpduGroupIdType TxIpduGroupMultiplicity);

	TxIpduGroupIdType
	Id () const;

	void
	Init (TxIpduGroupConfigType const * Config);

	void
	Init ();

	void
	Start (Bool Initialize);

	void
	Stop ();

private:
	static TxIpduGroupType TxIpduGroups_[cfOS_COM_ASCOM_TX_IPDU_GROUP_MULTIPLICITY];
	static Bitset<cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY> StartedTxIpduGroupsBitset_;
	static TxIpduGroupIdType TxIpduGroupMultiplicity_;
};

inline TxIpduGroupType &
TxIpduGroupType::Inst (TxIpduGroupIdType TxIpduGroupId) {
	return TxIpduGroups_[TxIpduGroupId];
}

inline void
TxIpduGroupType::InitAll (TxIpduGroupConfigType const * ConfigArray, TxIpduGroupIdType TxIpduGroupMultiplicity) {
	TxIpduGroupIdType i = 0;

	// We assume TxIpduGroupMultiplicity <= cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY
	for (; i < TxIpduGroupMultiplicity; ++i) {
		TxIpduGroups_[i].Init (&ConfigArray[i]);
	}

	for (; i < cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY; ++i) {
		// FIXME Uninit or stop or similar
	}
}

inline TxIpduGroupIdType
TxIpduGroupType::Id () const {
	return  this - TxIpduGroups_;
}

inline void
TxIpduGroupType::Init () {

}

inline void
TxIpduGroupType::Init (TxIpduGroupConfigType const * Config) {
	*(TxIpduGroupConfigType *)this = *Config;
	Init ();
}

}}}

#endif
