#include "TxSignalType.h"
#include "TxIpduType.h"

namespace os { namespace com { namespace ascom {

void
TxSignalType::Init () {
	// Although this is empty, we need a noninline stub here.
}

StatusType
TxSignalType::SendSignal (const void * SignalDataPtr) {
	return ProcessSendSignal (TxIpduType::Inst( IpduId ()), SignalDataPtr);
}

inline StatusType
TxSignalType::ProcessSendSignal (TxIpduType & TxIpdu, void const * SignalDataPtr) {
	// The simplest case is Pending Transfer property --> we just have to update the TxIpdu
	CopyFromSignalToSdu (TxIpdu.SduBuffer (), (UInt8 const *) SignalDataPtr);
	return E_OK;
}

TxSignalType TxSignalType::TxSignals_[cfOS_COM_ASCOM_TX_SIGNAL_MULTIPLICITY];

}}}
