//CXXFLAGS_EXTRA=-finline -finline-functions -finline-limit=2000

#include "os/irq/Guard.h"
#include "hw/hal/CPU.h"

namespace os { namespace irq {

/* the EpilogueContainer has to provide its own 
 * synchronization mechanism for (enqueue INTS dequeue)*/

void Guard::processEpilogues() {
//interrupts are enabled here
		while (epilogues_.isFilled())
			epilogues_.dequeue()
//and have to be here		
				->doEpilogue();
}

void Guard::relay(GateBase *epilogueObject) {
//interrupts are disabled here
		epilogues_.enqueue(epilogueObject);
}

EpilogueContainer Guard::epilogues_;

}} //os::irq;
