#ifndef __os_irq_Guard_h__
#define __os_irq_Guard_h__

#include "EpilogueContainer.h"
#include "stdinc.h"
#include "hw/hal/CPU.h"

namespace os { namespace irq {

class Guard {
public:
	static void enter () {}
	static void leave () {}
	
	static Bool isLocked() {
		return false;
	}

	//supposed to be called with interrupts disabled
	static void relay (Gate) CIAO_USE_J_RFE;
	
	//supposed to be called with interrupts enabled
	static void processEpilogues();
	
	static void init() {epilogues_.init();}
private:
	static os::irq::EpilogueContainer epilogues_;
};

}} //os::irq

#endif //__os_irq_Guard_h__

