#ifndef OS_IRQ_QUEUE_H_
#define OS_IRQ_QUEUE_H_

#include "ChainBase.h"
#include "stdinc.h"

class Queue : public ChainBase {
	ChainBase* tail;
	
public:
	void init () { tail = this; }

	void enqueue (ChainBase* item) {
		item->setNext(0);
		tail->setNext(item);
		tail=item;
	}
	
	/*this is a queue only for epilogues
	 *we presume a non-empty queue here!*/
	ChainBase* dequeue () {
		ChainBase* item;
		ChainBase* follow;

		item = getNext();

		if (!(follow=item->getNext()))
			tail = this;
		setNext(follow);

		return item;
	}
	
	Bool isFilled() {
		return (Bool) getNext();
	}
	
};

#endif /*QUEUE_H_*/
