// $Id: AppMode.h 1149 2010-03-09 13:24:34Z mike $
// Created: 2007-06-28 siwahofe

#ifndef __OS_KRN_APPMODE_H__
#define __OS_KRN_APPMODE_H__

#include "ciaoConfig.h"
#include "util/types.h"

namespace os { namespace krn {

struct AppMode {
	
	// data type to represent number of application modes (minimum one)
	typedef AppModeType Id;
	static const Id DEFAULT = OSDEFAULTAPPMODE;

	typedef uint_t_minbits <cfOS_NUMBER_OF_TASKS>::T TaskMask;

	TaskMask taskmask_;

	static AppMode& Inst (Id me);

	static TaskMask getTaskMask (Id of) {
		return Inst (of).taskmask_;
	}
};


extern AppMode theAppModes [];

inline AppMode& AppMode::Inst (AppMode::Id me) {
	return theAppModes [me];
}

}} // namespace os::krn
 
#endif // __OS_KRN_APPMODE_H__
