// $Id: Application.h 1149 2010-03-09 13:24:34Z mike $
// Created: 2007-07-23 siwahofe

#ifndef __OS_KRN_APPLICATION_H__
#define __OS_KRN_APPLICATION_H__

#include "util/types.h"
#include "ciaoConfig.h"


namespace os { namespace krn {

struct Application {

	
	// data type to represent number of OS applications plus INVALID_OSAPPLICATION
	typedef ApplicationType Id;
	static const Id INVALID = INVALID_OSAPPLICATION;

	static bool isTrusted (Id appid) {
		return Inst(appid).trusted_;
	}

	/* better would be something like
	 *   return ( appid < first_nontrusted_appid );
	 * 
	 * If this "first_nontrusted_appid" is never used within the libciao, it
	 * can simply be included as a preprocessor symbol (from UCInfo.h)
	 * however, this is not the case (due to the TASKDEF-Macro Workaround in
	 * os/krn/StaticTCBExt.h.
	 * Another possibility is to weave that information by a generated aspect,
	 * that way we make sure, that the libciao is always built again, when
	 * that aspect changes. */
	
	static Application& Inst (Id appid);
	
	bool trusted_;
};


extern Application theApplications [];

inline Application& Application::Inst (Application::Id appid) {
	return theApplications [appid];
}

}} // namespace os::krn
 
#endif // __OS_KRN_APPLICATION_H__
