// $Id$

#include "ciaoConfig.h"
#include "hw/hal/CPU.h"

#include "hw/hal/SystemTimer.h"

#include "os/krn/Counter.h"
#include "os/krn/Alarm.h"

namespace os { namespace krn {
	void Counter::init() {
#if cfOS_NUMBER_OF_COUNTERS > 0
		// FIXME we really do support a single counter only atm,
		// unless the other counters have the same ticksperbase value...
		hw::hal::SystemTimer::Inst ().windupPeriodical(Inst(0).ticksperbase);
#endif
	}

	void Counter::advanceCounter () {
		if(value == maxallowedvalue) {
			value = 0;
		} else {
			value++;
		}

		// least effort approach to get this working for now...	
		for(Alarm::Id aid=0; aid < cfOS_NUMBER_OF_ALARMS; aid++) {
			if((!Alarm::getArmed(aid)) || (&(Alarm::getConfiguration(aid)) != this)) {
				continue;
			}

			if(Alarm::getAbsoluteTime(aid) == value) {
				Alarm::trigger(aid);
			}
		}
	}
}}

Bool hw::irq::STM_SRC0::HWHandler () {
	// acknowledge
	hw::hal::SystemTimer::Inst ().irqAck ();

  // ISR1s are still allowed
  hw::hal::CPU::enable ();

	// we need to reconfigure the CompMatch reg every time :-(
	//hw::hal::SystemTimer::Inst ().windupPeriodical(os::krn::Counter::Inst(0).ticksperbase);
	
	for(os::krn::Counter::Id cid = 0; cid < cfOS_NUMBER_OF_COUNTERS; cid++) {
		os::krn::Counter::Inst(cid).advanceCounter();
	}

	return true;
}

