// $Id: types_arch.h 995 2009-08-11 14:26:31Z mike $
// Created:   26.06.2006 lohmann

/**
 * @file types_arch.h
 * @brief H8 architecure-specific primitive types and operations.
 * 
 * This file is ONLY included indirectly by types.h
 * 
 */

#ifdef __TYPES_H__
#ifndef __TYPES_ARCH_H__
#define __TYPES_ARCH_H__

// Using 8-bit indicies results in very inefficient and bloated
// code on H8, because of the @(d:16,Rn) addressing scheme.
// The compiler has to insert instructions to extend the index to 16-bit 
template< unsigned long long MAXVAL=16 >
struct index_t_value : public uint_t_min< 
	max< bytes_needed< MAXVAL >::RES, sizeof(UInt16) >::RES > {};
#define __TYPES_index_t_value	

		

#endif // !__TYPES_ARCH_H
#endif // __TYPES_H__
