#ifndef __INTRINSICS_H____
#define __INTRINSICS_H____

namespace {
	register void* _x86_ESP asm ("esp");
}

/* Additional intrinsics for direct register access */
#define _getSP() \
	_x86_ESP

#define _setSP(val) \
	_x86_ESP = (val)

/* push/pop an int32 ("D"ata) or a ptr ("A"ddress) on/from the stack */
#define _pushD(val) \
	{ register unsigned long newval = (unsigned long)(val); \
	  asm volatile( "pushl %0" : : "d" (newval) : "memory"); }

#define _popD() \
	({ register unsigned long res; \
	   asm volatile ("popl %0" : "=d" (res) : "memory"); \
	   res; })

#define _pushA(ptr) \
	{ register unsigned long newval = (unsigned long)(ptr); \
	  asm volatile( "pushl %0" : : "d" (newval) : "memory"); }

#define _popA() \
	({ register unsigned long res; \
	   asm volatile ("popl %0" : "=d" (res) : "memory"); \
	   res; })

// TODO: _debug() implementieren, aber wo?
#define _debug() asm volatile("cli\nhlt\n")

// TODO: Wohin mit _nop()?
inline void _nop() {
	asm volatile ("nop");
}

inline void _hlt() {
	asm volatile ("hlt");
}

#endif // __INTRINSICS_H____
