// $Id: types_arch.h 995 2009-08-11 14:26:31Z mike $
// Created:   26.06.2006 lohmann

/**
 * @file types_arch.h
 * @brief TC architecure-specific primitive types and operations.
 *
 * This file is ONLY included indirectly by types.h
 *
 */

#ifdef __TYPES_H__
#ifndef __TYPES_ARCH_H__
#define __TYPES_ARCH_H__

#include "intrinsics.h"


// x86 hasn't this nice count-leading-zeros instruction ;-)
template< class INT_TYPE > inline UInt highest1Bit( INT_TYPE n ) {

	int pos;
	for (pos = 0; n > 0; n >>= 1) {
		pos++;
	}

	return pos - 1;
}
#define __TYPES_highest1Bit

/*

// optimizes Versions of bit operations
// TODO: NOT TESTED YET

template< class INT_TYPE > inline INT_TYPE clearBit(INT_TYPE val, UInt32 bit_index ) {
	asm("insert %0, %0, 0, %1, 1" : "+d" (val) : "d" (bit_index) );
	return val;
}
#define __TYPES_clearBit

template< class INT_TYPE > inline INT_TYPE setBit(INT_TYPE val, UInt32 bit_index ) {
	asm("insert %0, %0, 1, %1, 1" : "+d" (val) : "d" (bit_index) );
	return val;
}
#define __TYPES_setBit

template< class INT_TYPE > inline Bool testBit(INT_TYPE val, UInt32 bit_index ) {
	Bool res;
	asm("extr.u %0, %1, %2, 1" : "=d" (res) : "d" (val) , "d" (bit_index) );
	return res;
}
#define __TYPES_testBit
*/

#endif // !__TYPES_ARCH_H
#endif // __TYPES_H__
