#ifndef ASSERT_H_
#define ASSERT_H_

#include "compiler.h"
#include "intrinsics.h"

#define __STRINGIFY(X) __STRINGIFY1(X)
#define __STRINGIFY1(X) #X

#define __JOIN( X, Y ) __JOIN1( X, Y )
#define __JOIN1( X, Y )__JOIN2(X,Y)
#define __JOIN2( X, Y ) X##Y


template <bool> struct STATIC_ASSERT_FAILURE;
template <> struct STATIC_ASSERT_FAILURE<true> { enum { value = 1 }; };


//! compile-time assertion macro
#define STATIC_ASSERT(test,msg)\
    struct __JOIN(ERROR##_##msg##_,__LINE__) {\
    	static void STATIC_ASSERTION_FAILED() {\
			enum res { value = ::STATIC_ASSERT_FAILURE< (bool)( test ) >::value };\
		}\
	};

//! compile-time error message
#define STATIC_ERROR(msg) STATIC_ASSERT(false,msg)


extern "C" void __ciao_assertion_handler( 
		const char* test, 
		const char* msg, 
		const char* file, 
		unsigned int line 
		); 


#define ASSERT(test,msg)\
	do {if( !((test)) ) __ciao_assertion_handler( __STRINGIFY(test), __STRINGIFY(ERROR_##msg), __FILE__, __LINE__ );} while(false) 

#endif /*ASSERT_H_*/
