#ifndef UTIL_BITSET_H
#define UTIL_BITSET_H

#include "util/metaprog.h"
#include "util/types.h"

#include "BitsetSingleElemImpl.h"
#include "BitsetMultiElemImpl.h"

// For now we assume that set, get and find bit functions are optimal
// for register sized types (UInt) so we always build up a Bitset with such types
// TODO check support for smaller Bitsets

// This is the interface to the Bitset templates
template<int BIT_LENGTH>
class Bitset : public metaprog::select<BIT_LENGTH <= 8 * sizeof(UInt),
										BitsetSingleElemImpl<UInt,BIT_LENGTH>,
										BitsetMultiElemImpl<UInt,BIT_LENGTH> >::T {

	typedef typename metaprog::select<BIT_LENGTH <= 8 * sizeof(UInt),
										BitsetSingleElemImpl<UInt,BIT_LENGTH>,
										BitsetMultiElemImpl<UInt,BIT_LENGTH> >::T BitsetImpl;
public:
	typedef typename BitsetImpl::IndexIteratorOnes IndexIteratorOnes;
	Bool __attribute__((always_inline))
	AnyCleared() const {
		return !this->AllSet();
	}

	Bool __attribute__((always_inline))
	AnySet() const {
		return !this->AllCleared();
	}

	// FIXME Maybe add nice operator[] with Proxy object
};

template<>
class Bitset<0> {
// FIXME Set Static Assert or make empty implementation
};

#endif
