#ifndef __ChainBase_h__
#define __ChainBase_h__

//! A single linked Chain
class ChainBase{
	protected:
		//! next pointer
		ChainBase* _next;
		
	public:
		
		//! constructor
		/*! 
		 * default constructor
		 */
		ChainBase():_next(0){}
		
		//! constructor
	 	/*!  
		 * \param chain is another Chain object which will be linked 
		 *  to the new Chain object
		 */
	 	ChainBase (ChainBase* chain):_next(chain){}
	 	
	 	
	 	
	 	//! copy constructor
	 	/*!
	 	 * \param chain is another \ref ChainBase object
	 	 */
	 	 ChainBase(ChainBase& chain){}
	 	 
	 	 //! destructor
	 	 ~ChainBase(){}
	 	
	 	//! Get the next Chain element
		/*!
		 * \return pointer to the next Chain object
		 */
		ChainBase* getNext() const
		{
			return this->_next;
		}
		
		//! Set the next Chain element
		/*!
		 * \param next is a pointer to the next chain element
		 */
	 	void setNext(ChainBase *next)
	 	{
			this->_next=next;
		}
		
		//! Find last element in Chain
		/*!
	 	* \return Pointer to the last element in Chain
	 	*/
		ChainBase* findLast() const;
					
};




#endif //__ChainBase_h__

