#ifndef __DlList_h__
#define __DlList_h__

#include "util/container/List.h"
#include "util/container/DlChain.h"

//! A double linked list
/*! Container with constant insertion and deletion time.
 *  Has bidirectional iterator
 *  This container can be instantiated with custom types and/or 
 *  allocators
 */
template<class T>
class DlList : public List< T, DlChain<T> >{

public:
		
		typedef List< T , DlChain<T> > Base;
		
		typedef typename Base::node_t node_t;
		
		//! Default constructor
		DlList():Base(){}
		
		//! Constructor
		/*!
		 * \param elem will be the first element in the List
		 */ 
		DlList(node_t* elem):Base(elem){}
		
		//! Copy Constructor 
		/*!
		 * \param list is another list object
		 */
		DlList(DlList& list):Base(list._front){}
}; 

#endif // __DlList_h__

