#ifndef __MemPool_h__
#define __MemPool_h__

#include "util/types.h"
#include "mem/MemPoolBase.h"

class MemPool : public MemPoolBase {

public:
	typedef UInt8 value_t;
	typedef Ptr pointer_t;
	
private:
	pointer_t _addr;
	size_t _size;

public:
	MemPool():_addr(0),_size(0){};
	MemPool(UInt8* addr,int size):_addr(addr),_size(size){};
	MemPool(MemPool& mpool):_addr(mpool._addr),_size(mpool._size){}
	~MemPool(){};
	
	pointer_t addr() {
		return static_cast<pointer_t>(_addr);
	}
	
	size_t size() {
		return _size;
	}
};

#endif // __MemPool_h__
