#ifndef __MEM_H__
#define __MEM_H__

#include "util/types.h"

//! Helper function to copy unintitialized memory
template <class SourceIter,class TargetIter >
TargetIter uninitialized_copy(SourceIter source ,SourceIter end,TargetIter target){
	typedef typename TargetIter::value_t value_t;
	
	//! invoke copy constructor for each element
	while (begin != end){
		new (static_cast<void*>(&*target)) value_t(*source);
		target++;
		source++;
	}
	return target;
}




#endif //__MEM_H__