#include "hw/irq/STM.h"
#include "hw/hal/CPU.h"
#include "hw/hal/SystemTimer.h"
#include "hw/hal/Out0.h"

// The really invoked handler
Bool cfHAL_IRQHANDLER_ATTRIBUTES hw::hal::SystemTimer::IRQ::HWHandler() {
	//direct handler omitting CiAO's interrupt management

	// acknowledge the irq
	hw::hal::SystemTimer::Inst().irqAck();

	// Toggle LED
	hw::hal::Out0::Inst().toggle();
	
	return false;
}


using namespace hw::hal;

long counter = 0;

int main() {

	unsigned usec = 5 * 100000;
	
	SystemTimer::Inst().windupPeriodical( SystemTimer::usec2units( usec ) );
	SystemTimer::Inst().start();
	SystemTimer::IRQ::enable();
	CPU::enable();

	

	while( true ) {
		asm volatile("nop");
		counter++;
		asm volatile("nop");
	}
	return 0;		
}
