/** \author Christian Meier
 *  \version $Id: appcode.cpp 970 2009-04-16 09:29:53Z sichmeie $
 *
 *
 */

#include "appcode.h"
#include "as/AS.h"
#include "util/types.h"
#include "objects.h"
#include "stdio.h"

#include "AsCom_Cfg.h"
#include "os/com/ComStack_Types.h"

// Only neccessary for reinjection of sent pdus into ascom
#include "os/com/ascom/rx/RxIpduType.h"

// We allocate a buffer for two ipdus
Bool TxIpduSent[1] = {false};
UInt8 SduBuffer[1][8];

UInt8 TxSignal[4];
UInt8 RxSignal[4];

// Initialization task
void Alpha::functionTaskInitTask () {
	AS::Com_TxIpduGroupStart (0, true);
	AS::Com_RxIpduGroupStart (0, true);
	AS::SetRelAlarm (NetworkAlarm, 5000000/OSTICKDURATION, 5000000/OSTICKDURATION);
	AS::SetRelAlarm (ReceiveAlarm, 25000000/OSTICKDURATION, 25000000/OSTICKDURATION);
	AS::SetRelAlarm (SendAlarm, 100000000/OSTICKDURATION, 100000000/OSTICKDURATION);
}

// Task for emulation of the sending node
void Alpha::functionTaskSendTask () {
	AS::Com_SendSignal (0,  TxSignal);
	AS::TerminateTask ();
}

// Task for emulation of the receiving node
void Alpha::functionTaskReceiveTask () {
	AS::Com_ReceiveSignal (0,  RxSignal);
	AS::TerminateTask ();
}

// Task for emulation of the network
void Alpha::functionTaskNetworkTask () {
	// In this evaluation case the ipdu has NONE TM
	// so we have to get the data on our own
	// Internal implementation of real lower layer would directly call
	// TxIpduType::Inst(0).TriggerTransmit(), because it would be called from inside enterKernel/leaveKernel
	// but we call it directly from task level --> we use AS::Com_TriggerTransmit()
	AS::Com_TriggerTransmit (0, SduBuffer[0]);
	os::com::ascom::RxIpduType::Inst (0).RxIndication (SduBuffer[0]);

/*
	if (TxIpduSent[0]) {
		TxIpduSent[0] = false;
		os::com::ascom::RxIpduType::Inst(0).RxIndication(SduBuffer[0]);
	}

	if (TxIpduSent[1]) {
		TxIpduSent[1] = false;
		os::com::ascom::RxIpduType::Inst(1).RxIndication(SduBuffer[1]);
	}
*/
	AS::TerminateTask();
}

void Alpha::functionTaskMainFunctionTask () {
	AS::Com_MainFunctionTx ();
}

// For simplicity we use the TxIpduCallout for getting the sent ipdus
// so currently we do not include variants without TxIpduCallout feature
// for evaluation.
/*Bool
DefaultTxIpduCallout (os::com::PduIdType PduId, UInt8 const * SduPtr) {
	// We want to remember that network task has to "receive" the data
	if (PduId == 0) {
		memcpy (SduBuffer[0], SduPtr, ASCOM_IPDU0_LENGTH);
		TxIpduSent[0] = true;
	} else if (PduId == 1) {
		memcpy (SduBuffer[1], SduPtr, ASCOM_IPDU1_LENGTH);
		TxIpduSent[1] = true;
	}

	return true;
}
*/

namespace os { namespace krn {

	Alarm theAlarms [] = {
		{{OSMAXALLOWEDVALUE_SYSTEMCOUNTER, OSTICKSPERBASE_SYSTEMCOUNTER, OSMINCYCLE_SYSTEMCOUNTER}, 0, 0, SendTask, Alarm::INVALID, Alarm::INVALID},
		{{OSMAXALLOWEDVALUE_SYSTEMCOUNTER, OSTICKSPERBASE_SYSTEMCOUNTER, OSMINCYCLE_SYSTEMCOUNTER}, 0, 0, ReceiveTask, Alarm::INVALID, Alarm::INVALID},
		{{OSMAXALLOWEDVALUE_SYSTEMCOUNTER, OSTICKSPERBASE_SYSTEMCOUNTER, OSMINCYCLE_SYSTEMCOUNTER}, 0, 0, NetworkTask, Alarm::INVALID, Alarm::INVALID}
	};
}}

