#include "../cfInitializers.h"
#include "os/com/ComStack_Types.h"

#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/Filter.h"
#include "os/com/ascom/ConfigTypes.h"

#include "AsCom_Cfg.h"

namespace os { namespace com { namespace ascom {

// These tx signals are not byte aligned, the tx signal 0 is 1 bit long,
// tx signal 1 is 2 bits long, tx signal 2 is 3 bits long and so on.
static TxSignalConfigType const TxSigConfigs[] = {
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 0, 0, 0, 0, TRIGGERED, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 0, 0, 1, 2, TRIGGERED, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 0, 0, 3, 5, TRIGGERED, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 0, 1, 6, 1, TRIGGERED, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 1, 1, 2, 6, TRIGGERED, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 1, 2, 7, 4, TRIGGERED, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 2, 3, 5, 3, TRIGGERED, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8, 3, 4, 4, 3, TRIGGERED, Always, 0, 0)
};

static TxIpduConfigType const TxIpduConfigs[] = {
	OS_COM_ASCOM_TX_IPDU_CONFIG_INITIALIZER(0, 0, 7, 1, 0, 5, NULL, 0, 4, 2, false, DIRECT, 0, 0, DIRECT, 0, 0)
};

static TxIpduGroupConfigType const TxIpduGroupConfigs [] = {
	OS_COM_ASCOM_TX_IPDU_GROUP_CONFIG_INITIALIZER(0, 0)
};

extern ConfigType const DefaultConfig;
ConfigType const DefaultConfig = OS_COM_ASCOM_CONFIG_INITIALIZER(NULL, 0, NULL, 0, NULL, 0, NULL, 0, TxSigConfigs, 8, NULL, 0, TxIpduConfigs, 1, TxIpduGroupConfigs, 1);

}}}
