#include "../cfInitializers.h"
#include "os/com/ComStack_Types.h"

#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/Filter.h"
#include "os/com/ascom/ConfigTypes.h"

#include "AsCom_Cfg.h"

namespace os { namespace com { namespace ascom {

static os::com::ascom::TxSignalConfigType const TxSigConfigs[] = {
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt16, 0, 0, 0, 7, TRIGGERED, MaskedNewEqualsX<UInt16>, 0x04, 0xFFFC),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(1, UInt16, 0, 1, 0, 7, TRIGGERED, OneEveryN, 0, 3),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(2, UInt16, 0, 3, 0, 7, TRIGGERED, NewIsOutside<UInt16>, 815, 4711)
};

static os::com::ascom::TxIpduConfigType const TxIpduConfigs[] = {
	OS_COM_ASCOM_TX_IPDU_CONFIG_INITIALIZER(0, 0, 0, 1, 0, 2, NULL, 0, 0, 0, true, DIRECT, 0, 0, NONE, 0, 0),
	OS_COM_ASCOM_TX_IPDU_CONFIG_INITIALIZER(0, 1, 1, 1, 0, 2, NULL, 0, 0, 0, true, DIRECT, 0, 0, NONE, 0, 0),
	OS_COM_ASCOM_TX_IPDU_CONFIG_INITIALIZER(0, 2, 2, 1, 0, 2, NULL, 0, 0, 0, true, DIRECT, 0, 0, NONE, 0, 0)
};

static TxIpduGroupConfigType const TxIpduGroupConfigs [] = {
	OS_COM_ASCOM_TX_IPDU_GROUP_CONFIG_INITIALIZER(0, 2)
};

extern ConfigType const DefaultConfig;
ConfigType const DefaultConfig = OS_COM_ASCOM_CONFIG_INITIALIZER(NULL, 0, NULL, 0, NULL, 0, NULL, 0, TxSigConfigs, 3, NULL, 0, TxIpduConfigs, 3, TxIpduGroupConfigs, 1);

}}}
