/** \author Christian Meier
 *  \version $Id: appcode.cpp 965 2009-03-29 23:01:18Z sichmeie $
 *
 */

#include "appcode.h"
#include "as/AS.h"
#include "util/types.h"
#include "objects.h"
#include "stdio.h"

#include "os/com/ComStack_Types.h"

#include "AsCom_Cfg.h"

Bool TxEvent = false;

void
testTMS (UInt8 SignalId, UInt16 Value, Bool TxEventWished) {
	TxEvent = false;

	AS::Com_SendSignal(SignalId,  &Value);

	if (TxEventWished && !TxEvent) {
		printf("TMS hasn't caused a wished transmission!\r\n");
	} else if (!TxEventWished && TxEvent) {
		printf("TMS has caused an unwished transmission!\r\n");
	}
}

TASKDEF(Alpha,Task0) {
	AS::Com_TxIpduGroupStart(0, true);

	// TMS Test with MaskedNewEqualsX and UInt16
	// Filter is configured to be true if (Value & 0xFFFC) == 0x0004
	// so TMC with
	// (0 <= Value <= 3) || (8 <= Value)
	// should evaluate to false
	// and (4 <= Value <= 7) should lead to true for TMC.
	// The corresponding ipdu has only this signal associated to it.
	// so TMS = TMC of that signal.
	testTMS (0, 0, false);
	testTMS (0, 1, false);
	testTMS (0, 2, false);
	testTMS (0, 3, false);
	testTMS (0, 4, true);
	testTMS (0, 5, true);
	testTMS (0, 6, true);
	testTMS (0, 7, true);
	testTMS (0, 8, false);
	testTMS (0, 9, false);

	// Conforming to COM231 a period of 3 means three SendSignals without tx
	// between two tx requests.
	testTMS (1, 0, 		true);
	testTMS (1, 123,	false);
	testTMS (1, 2,		false);
	testTMS (1, 4711,	false);
	testTMS (1, 4,		true);
	testTMS (1, 5,		false);
	testTMS (1, 0,		false);
	testTMS (1, 7,		false);
	testTMS (1, 42,		true);
	testTMS (1, 815,	false);

	testTMS (2, 0, 		true);
	testTMS (2, 814,	true);
	testTMS (2, 815,	false);
	testTMS (2, 816,	false);
	testTMS (2, 1000,	false);
	testTMS (2, 4710,	false);
	testTMS (2, 4711,	false);
	testTMS (2, 4712,	true);
	testTMS (2, 0x7FFF,	true);
	testTMS (2, 0x8000,	true);
	testTMS (2, 0xFFFF,	true);

	AS::TerminateTask();
}

Bool DefaultTxIpduCallout(os::com::PduIdType PduId, UInt8 const * SduPtr) {
	// ASCOM_TX_SIGNAL_SMALL is configured to have DIRECT TM if TMS evaluates to true
	// and NONE TM if TMS evaluates to false
	// so TxIpduCallout should only be called if DIRECT TM is selected.
	TxEvent = true;
	return true;
}
