#ifndef __HOOKS_H__
#define __HOOKS_H__

#include "stdio.h"
#include "as/AS.h"

inline void UserPreTaskHook1 () {
	TaskType id;
	AS::GetTaskID (id);
	printf ("PreTaskHook1 before Task %i.\r\n", id);
}

inline void UserPreTaskHook2 () {
	TaskType id;
	AS::GetTaskID (id);
	printf ("PreTaskHook2 before Task %i.\r\n", id);
}

inline void UserPostTaskHook () {
	TaskType id;
	AS::GetTaskID (id);
	printf ("PostTaskHook after Task %i.\r\n", id);
}

inline void UserStartupHook () {
	printf ("StartupHook\r\n");
}

inline void UserShutdownHook (StatusType arg) {
	printf ("ShutdownHook, error was %i.\r\n", arg);
}

inline void UserErrorHook (StatusType error) {
	printf ("ErrorHook, error was %i.\r\n", error);
	printf ("ErrorHook: activating an invalid task.\r\n");
	AS::ActivateTask (4711);
	printf ("ErrorHook ending.\r\n");
}

#endif // __HOOKS_H__
