#include "stdio.h"
#include "hw/hal/DebugPort.h"
#include "hw/hal/CPU.h"
#include "os/krn/SchedImpl.h"
#include "os/krn/EnterLeave.h"

int foo = 0;
namespace a {
	int foo = 0;
	class Bar {
		static Bar inst;
	};
	Bar Bar::inst;
}
class Bar {
	static Bar inst;
};
Bar Bar::inst;

#define theSched os::krn::SchedImpl::Inst()

void task0() {
	printf( "task0 has been started, enters the kernel\r\n" );
	os::krn::enterKernel();
	printf( "task0 awakes task2, sets needReschedule\r\n" );
	theSched.awake( 2 );
	theSched.setNeedReschedule();
	printf( "task0 leaves the kernel\r\n" );
	os::krn::leaveKernel();
	printf( "task0 is running again, enters kernel\r\n" );
	os::krn::enterKernel();
	printf( "task0 activates tasks 0,1,2,3\r\n" );
	theSched.activate( 0 );
	theSched.activate( 1 );
	theSched.activate( 2 );
	theSched.activate( 3 );
	printf( "task0 exits\r\n" );
	theSched.exit( 0 );
	_debug();
}
void task1() {
	printf( "task1 has been started, enters the kernel\r\n" );
	os::krn::enterKernel();
	printf( "task1 exits\r\n" );
	theSched.exit( 1 );
	_debug();
}
void task2() {
	printf( "task2 has been started, enters the kernel\r\n" );
	os::krn::enterKernel();
	printf( "task2 actives task3, sets needReschedule\r\n" );
	theSched.activate( 3 );
	theSched.setNeedReschedule();
	printf( "task2 blocks\r\n" );
	theSched.block( 2 );
	printf( "task2 leaves the kernel\r\n" );
	os::krn::leaveKernel();
	printf( "task2 is running again, enters the kernel\r\n" );
	os::krn::enterKernel();
	printf( "task2 exits\r\n" );
	theSched.exit( 2 );
	_debug();
}
void task3() {
	printf( "task3 has been started, enters the kernel\r\n" );
	os::krn::enterKernel();
	printf( "task3 exits\r\n" );
	theSched.exit( 3 );
	_debug();
}

namespace os { namespace krn {
	const int STACK = 64;
	UInt32 stack0[ STACK ];
	UInt32 stack1[ STACK ];
	UInt32 stack2[ STACK ];
	UInt32 stack3[ STACK ];
		
	Task myTasks[] = {
		 {0, Task::READY | Task::TERMINATED, task0, &stack0[ STACK ] },	
		 {1, Task::READY | Task::TERMINATED, task1, &stack1[ STACK ] },	
		 {2, Task::READY | Task::TERMINATED, task2, &stack2[ STACK ] },	
		 {3, Task::READY | Task::TERMINATED, task3, &stack3[ STACK ] }	
	};
}}


int main() {

	theSched.setTaskTable( os::krn::myTasks, 4 );
	os::krn::enterKernel();
	hw::hal::CPU::enable();
	theSched.start();
	_debug();
	return 0;
}
