#include "util/container/ChainBase.h"

class CustomChain :public ChainBase{
public:
	typedef ChainBase Base;
	typedef int value_t;
	
private:
	value_t _value;

public:
	CustomChain(value_t value):Base(),_value(value){}
	CustomChain(Base* next,value_t value):Base(next),_value(value){} 
	CustomChain(CustomChain &chain):Base(chain),_value(chain._value){}
	~CustomChain(){}
	
	value_t value()	const{
		return _value;
	}
	
	CustomChain* getNext(){
		return static_cast< CustomChain* >( Base::getNext() );
	}
};


int main (){
	
//	Construct a Chain

	CustomChain i2(123456);
	CustomChain i1(&i2,23);
	CustomChain i0(&i1,42);
	
	// Create iterator
    CustomChain* iter = &i0;

    int ret = 0;
    while(iter != 0){
        ret += iter->value(); 
        iter = iter->getNext();
    }
	return ret;
}

#ifndef makeARCH_i386
extern "C" void start(){
	main();
}

extern "C" void exit(){}
#endif 

