#include <tut.h>
#include "mem/Allocator.h"
#include "mem/MemPool.h"
#include "mem/StaticMemPool.h"
#include "mem/strategy/NeverFree.h"
#include "mem/strategy/FixedFit.h"
#include <iostream>
using namespace std;


namespace tut
{
  // Data used by each test
  struct allocator_basic
  { 
  	enum{SIZE=3};
  	typedef int value_t;
  	value_t pool[SIZE];
  	//MemPool mempool;
  	typedef Allocator<MemPool,FixedFit< sizeof(value_t) > > A0;
    //A0 alloc_0;
    
    allocator_basic(){}
  };

  // Test group registration
  typedef test_group<allocator_basic> factory;
  typedef factory::object object;
}

namespace
{
  tut::factory tf("allocator basic operations");
}

namespace tut
{
	
   /**
   * Checks used operation
   */
  template<>
  template<>
  void object::test<1>()
  {
  	MemPool mp((UInt8*)pool,sizeof pool );
  	A0 alloc_0(mp);
  	//cout << alloc_0.used();
    ensure("no used memory locations",alloc_0.used()==0);
    
  }
  
  /**
   * Checks allocate operation
   */
  template<>
  template<>
  void object::test<2>()
  {
  	MemPool mp((UInt8*) pool,sizeof pool );
  	A0 alloc_0(mp);
    value_t* a= (value_t*) alloc_0.allocate(sizeof(value_t));
    ensure("pointer to memory location is not null",a != 0);
	UIntPtr size=sizeof(value_t);
    alloc_0.allocate2(size);
    alloc_0.allocate(sizeof(value_t));
    alloc_0.allocate(sizeof(value_t));
    a= (value_t*) alloc_0.allocate(sizeof(value_t));
    ensure("pointer to memory location is null",a == 0);
    
    
  }
  

}
