#include <tut.h>
#include <tut_reporter.h>
#include <signal.h>
#include <iostream>



namespace tut
{
  test_runner_singleton runner;
}

void signal_to_exception(int)          
{
  throw std::runtime_error("killing signal catched");
}

int main()
{
  signal(SIGSEGV,signal_to_exception);         
  signal(SIGILL,signal_to_exception);
  
  tut::reporter reporter;
  tut::runner.get().set_callback(&reporter);

  
  try
  {
    tut::runner.get().run_tests();
  }
  catch( const std::exception& ex )
  {
    std::cerr << "tut raised ex: " << ex.what() << std::endl;
    return 1;
  }

  return 0;
}
