
#include <tc1796b/port0-struct.h>

static PORT0_t *port0 = (PORT0_t*) P0_BASE;

/**
 * Setze port 0.5 bis 0.15 in output mode. Da haengen
 * unsere roten LEDS dran!
 */
void init_redleds() {
	/* initialize P0.15 .. P0.5 in output mode */
	port0->IOCR4.bits.PC1 = 0x8;
	port0->IOCR4.bits.PC2 = 0x8;
	port0->IOCR4.bits.PC3 = 0x8;
	port0->IOCR8.bits.PC0 = 0x8;
	port0->IOCR8.bits.PC1 = 0x8;
	port0->IOCR8.bits.PC2 = 0x8;
	port0->IOCR8.bits.PC3 = 0x8;
	port0->IOCR12.bits.PC0 = 0x8;
	port0->IOCR12.bits.PC1 = 0x8;
	port0->IOCR12.bits.PC2 = 0x8;
	port0->IOCR12.bits.PC3 = 0x8;
}

/**
 * Setze die in mask angegebenen leds.
 * bit 0 ist dabei die erste (ganz rechts)
 */
void light_leds(unsigned int mask){
  /* setze alle resetbits */
  unsigned int resetbits = 0xFFFF0000 << 5;

  /* Betrachte nur die ersten 11 bits */
  mask &= (2 << 12) - 1; 

  /* erste led faengt bei Port 0.5 an */
  mask = mask << 5;

  /* die gewuenchsten bits sollen nicht resettet werden */
  resetbits = resetbits & (~ ( mask << 16 ));
  
  /* lasse die gewuenschten leds nun aufleuchten, loesche
     die ungewuenschten */
  mask = mask | resetbits;

  port0->OMR.reg = mask;
}
