<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="1.0">

  <xsl:include href="../common.xsl" />

  <xsl:template match="ciaoApp">
  	<xsl:text>//generated CiAO runtime
#ifndef UCINFO_H_
#define UCINFO_H_

#include "objects.h"
</xsl:text>
	<xsl:text>&#10;#define FIRST_NONTRUSTED_APP </xsl:text>
	<xsl:value-of select="count(osapplication[@trusted='true'])"></xsl:value-of>
	<xsl:text>&#10;&#10;</xsl:text>


	<xsl:for-each select="component">
		<xsl:variable name="classname">
			<xsl:call-template name="component_classname">
				<xsl:with-param name="name" select="@name"/>
			</xsl:call-template>		
		</xsl:variable>
		
		<xsl:call-template name="forwarddecl_in_namespace">
			<xsl:with-param name="classname" select="$classname"/>
		</xsl:call-template>
		
		<xsl:text>&#10;</xsl:text>						
	</xsl:for-each>

	<xsl:for-each select="isr">
		<xsl:text>namespace hw { namespace irq {&#10;</xsl:text>
		<xsl:text>class </xsl:text>
		<xsl:value-of select="@device"/>
		<xsl:text>;&#10;</xsl:text>						
		<xsl:text>}}&#10;</xsl:text>						
	</xsl:for-each>
<xsl:text>
namespace os {

template&lt;typename COMPONENTCLASS&gt;
struct UCInfo {};

</xsl:text>

	<xsl:for-each select="osapplication">
		<xsl:variable name="appid">
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:for-each select="componentref">
			<xsl:text>template&lt;&gt; struct UCInfo&lt;</xsl:text>
			<xsl:call-template name="component_classname">
				<xsl:with-param name="name" select="@name"/>
			</xsl:call-template>
			<xsl:text>&gt; {enum {APP=</xsl:text>
			<xsl:value-of select="$appid"/>
			<xsl:text>};};&#10;</xsl:text>
		</xsl:for-each>
	</xsl:for-each>

<xsl:text>


template&lt;typename IRQ&gt;
struct IRQInfo {};

</xsl:text>

	<xsl:for-each select="isr">
		<xsl:text>template&lt;&gt; struct IRQInfo&lt;hw::irq::</xsl:text>
		<xsl:value-of select="@device"/>
		<xsl:text>&gt; {enum {ISRID=</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>};};&#10;</xsl:text>
	</xsl:for-each>

<xsl:text>

#if cfOS_NUMBER_OF_CATEGORY_2_ISRS > 0
#include "os/krn/ISR.h"

template&lt;os::krn::ISR::Id ISRID&gt;
struct ISRInfo {};
#endif // cfOS_NUMBER_OF_CATEGORY_2_ISRS

</xsl:text>

	<xsl:for-each select="isr">
		<xsl:text>template&lt;&gt; struct ISRInfo&lt;</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>&gt; {typedef hw::irq::</xsl:text>
		<xsl:value-of select="@device"/>
		<xsl:text> IRQ;};&#10;</xsl:text>
	</xsl:for-each>

<xsl:text>

} // os

#endif /*UCINFO_H_*/
</xsl:text>

  </xsl:template>

</xsl:stylesheet>
