<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
version="1.0">
<xsl:import href="../ComStacksCommon.xsl"/>
<xsl:output method="text"/>
<xsl:strip-space elements="*" />

<xsl:template match="/ComStacks">
#ifndef HW_DEV_CAN_CFG_H
#define HW_DEV_CAN_CFG_H

//#include &#34;ComStack_Types.h&#34;
#include &#34;node.h&#34;
#include &#34;hw/dev/can/ConfigTypes.h&#34;

<xsl:apply-templates match="/ComStacks/Node"/>

#endif /* HW_DEV_CAN_CFG_H */
</xsl:template>


<!-- Template for Can group on one node -->
<xsl:template match="/ComStacks/Node/Can">
namespace hw { namespace dev { namespace can {
<xsl:apply-templates select="Module"/>
};};};
</xsl:template>


<!-- Template for a Can Module -->
<xsl:template match="/ComStacks/Node/Can/Module">
// The following are the public declarations of the module <xsl:value-of select="@Name"/>

#define cfHW_DEV_CAN_<xsl:value-of select="translate(@Name, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
<xsl:text>_USED_NUM_HW_OBJECTS </xsl:text><xsl:value-of select="count(RxHwObject) + count(TxHwObject)"/>
#define cfHW_DEV_CAN_<xsl:value-of select="translate(@Name, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
<xsl:text>_USED_NUM_CONTROLLERS </xsl:text><xsl:value-of select="count(Controller)"/>
<!-- #define cfHW_DEV_CAN_<xsl:value-of select="translate(@Name, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
<xsl:text>_TIMEOUT_DURATION_FACTOR </xsl:text><xsl:value-of select="@TimeoutDurationFactor"/> -->

namespace <xsl:value-of select="@Name"/> {
<xsl:apply-templates select="Controller" />

extern ConfigType Config;

};
</xsl:template>


<!-- Template for a can controller -->
<xsl:template match="/ComStacks/Node/Can/Module/Controller">
extern ControllerConfigType ControllerId<xsl:value-of select="@ControllerId"/><xsl:text>_Configs[];</xsl:text>
</xsl:template>

</xsl:stylesheet>

